'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: b_upd_DatabaseTypes.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:53 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : marc.schwanz@sun.com
'*
'* short description : DatabaseTypes routines for Base Update Test
'*
'************************************************************************
'*
' #1 tTabAdabasOne
' #1 tTabAdabasTwo
' #1 tTabODBC     
' #1 tTabJDBC     
' #1 tTabdBase
' #1 tTabADO
' #1 tTabTEXTBase
' #1 tTabSpreadsheet
'*
'\***********************************************************************************
Dim gCountOfTypes as integer

sub b_upd_DatabaseTypes

   printlog "------------------ b_upt_DatabaseTypes.inc ---------------------"   
   printlog "-------------------- Database Types ----------------------"
     
   if gPlatform <> "x86" then
     call tTabAdabasOne
     call tTabAdabasTwo
   end if
     call tTabODBC     
     call tTabJDBC     
     call tTabdBase
   if gPlatgroup = "w95" then
     call tTabADO
   end if
     call tTabTEXTBase
     call tTabSpreadsheet
     
end sub

'-------------------------------------------------------------------------

testcase tTabAdabasOne
 Dim ListCountA as integer
 dim i as integer
 '/// Description ///'
 printlog "tab page Adabas"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  NewDatasource.Click	
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  DatabaseType.Select(2)
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabODBC
 Kontext "TabODBC"
  call Dialogtest(TabODBC)
  ListCountA = Adabas_CharacterSet.GetItemCount
  if ListCountA <> 53 then
    warnlog "There should be 53 character sets available but there are " & ListCountA & " sets available!?"
  end if  
  for i = 1 to ListCountA
        printlog Adabas_CharacterSet.GetItemText(i)
        select case i
            case 1:
                if Instr(Adabas_CharacterSet.GetItemText(i),"System") = 0 then warnlog "The character set isn't right"
            case 2:            
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1252/WinLatin 1)") = 0 then warnlog "The character set isn't right"
            case 3:    
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Apple Macintosh)") = 0 then warnlog "The character set isn't right"
            case 4:   
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-437/US)") = 0 then warnlog "The character set isn't right"
            case 5:  
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-850/") = 0 then warnlog "The character set isn't right"
            case 6: 
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-860/") = 0 then warnlog "The character set isn't right"
            case 7:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-861/") = 0 then warnlog "The character set isn't right"
            case 8:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-863/") = 0 then warnlog "The character set isn't right"
            case 9:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-865/") = 0 then warnlog "The character set isn't right"
            case 10:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ASCII/US)") = 0 then warnlog "The character set isn't right"
            case 11:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-1)") = 0 then warnlog "The character set isn't right"
            case 12:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-2)") = 0 then warnlog "The character set isn't right"
            case 13:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-3)") = 0 then warnlog "The character set isn't right"
            case 14:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-4)") = 0 then warnlog "The character set isn't right"
            case 15:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-5)") = 0 then warnlog "The character set isn't right"
            case 16:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-6)") = 0 then warnlog "The character set isn't right"
            case 17:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-7)") = 0 then warnlog "The character set isn't right"
            case 18:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-8)") = 0 then warnlog "The character set isn't right"
            case 19:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-9)") = 0 then warnlog "The character set isn't right"
            case 20:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-14)") = 0 then warnlog "The character set isn't right"
            case 21:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-15/EURO)") = 0 then warnlog "The character set isn't right"
            case 22:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-852)") = 0 then warnlog "The character set isn't right"
            case 23:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-862)") = 0 then warnlog "The character set isn't right"
            case 24:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-864)") = 0 then warnlog "The character set isn't right"
            case 25:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(DOS/OS2-866/") = 0 then warnlog "The character set isn't right"
            case 26:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-874)") = 0 then warnlog "The character set isn't right"
            case 27:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1250/WinLatin 2)") = 0 then warnlog "The character set isn't right"
            case 28:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1251)") = 0 then warnlog "The character set isn't right"
            case 29:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1253)") = 0 then warnlog "The character set isn't right"
            case 30:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1254)") = 0 then warnlog "The character set isn't right"
            case 31:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1255)") = 0 then warnlog "The character set isn't right"                           
            case 32:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1256)") = 0 then warnlog "The character set isn't right"                           
            case 33:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-1257)") = 0 then warnlog "The character set isn't right"
            case 34:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Shift-JIS)") = 0 then warnlog "The character set isn't right"                           
            case 35:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(GB-2312)") = 0 then warnlog "The character set isn't right"
            case 36:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(GBT-12345)") = 0 then warnlog "The character set isn't right"                           
            case 37:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(GBK/GB-2312-80)") = 0 then warnlog "The character set isn't right"
            case 38:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Big5)") = 0 then warnlog "The character set isn't right"                           
            case 39:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(EUC-JP)") = 0 then warnlog "The character set isn't right"
            case 40:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-2022-JP)") = 0 then warnlog "The character set isn't right"                           
            case 41:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-2022-CN)") = 0 then warnlog "The character set isn't right"
            case 42:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(KOI8-R)") = 0 then warnlog "The character set isn't right"                           
            case 43:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(UTF-7)") = 0 then warnlog "The character set isn't right"
            case 44:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(UTF-8)") = 0 then warnlog "The character set isn't right"                           
            case 45:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-10)") = 0 then warnlog "The character set isn't right"
            case 46:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-13)") = 0 then warnlog "The character set isn't right"                           
            case 47:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(KOI8-U)") = 0 then warnlog "The character set isn't right"
            case 48:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-2022-KR)") = 0 then warnlog "The character set isn't right"                           
            case 49:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(Windows-Johab-1361)") = 0 then warnlog "The character set isn't right"
            case 50:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(GB-18030)") = 0 then warnlog "The character set isn't right"                           
            case 51:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(BIG5-HKSCS)") = 0 then warnlog "The character set isn't right"
            case 52:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(ISO-8859-11/TIS-620)") = 0 then warnlog "The character set isn't right"
            case 53:
                if Instr(Adabas_CharacterSet.GetItemText(i),"(KOI8-U)") = 0 then warnlog "The character set isn't right"
        end select      
  next  
  
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabAdabasStatistics
  '  TabControl.SetPageId(19213)
  sleep(2)
 Kontext "TabAdabasStatistics"
  call Dialogtest(TabAdabasStatistics)
  Extended.Click
  sleep(4)
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
   if MessageBox.GetRT = 376 then
    Messagebox.OK
   end if
  end if
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabAdabasTwo
 Dim ListCountA as integer
 Dim CountOfPages as integer
 printlog "tab page Adabas when 'New data source'-button has been used"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  NewDataSource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  DatabaseType.Select(2)
 Kontext "DataSourceAdministration"
  CountOfPages = TabControl.GetPageCount
  printlog "Page count: " & CountOfPages
  if CountOfPages <> 7 then
       warnlog "There are not 7 tab pagesavailable! Bug!"
  end if
  sleep(1)
  ' check if it's OOo because in OOo the button newdatabase is not available.
  if gOOo = 0 then 
      Kontext "TabGeneral"
      if NewDatabase.IsEnabled then 
         NewDatabase.Click
        Kontext "Messagebox"
         if Messagebox.Exists(2) then
          if MessageBox.GetRT = 304 then
           Messagebox.Ok
          end if
         end if
        try
          Kontext "CreateNewAdabasDatabase"
           call Dialogtest(CreateNewAdabasDatabase)
           AdminPasswordBtn.Click
           Kontext "Passwort"
            call Dialogtest(Passwort)
            PasswortName.SetText "JustAnother"
            PasswortBestaetigen.SetText "DayInParadise"
            Passwort.OK
            Kontext "Messagebox"
              if Messagebox.Exists(2) then
               if Messagebox.GetRT = 304 then
                 Messagebox.OK
               end if
                else
                warnlog "Password verification failed!!!"
              end if
           Kontext "Passwort"
            Passwort.Cancel
          Kontext "CreateNewAdabasDatabase"
           ControlPasswordBtn.Click
           Kontext "Passwort"
            call Dialogtest(Passwort)
            Passwort.Cancel
           Kontext "CreateNewAdabasDatabase"
            DomainPasswordBtn.Click
           Kontext "Passwort"
            call Dialogtest(Passwort)
            Passwort.Cancel
           Kontext "CreateNewAdabasDatabase"
            SysDevSpaceBtn.Click
           Kontext "SpeichernDlg"
            call Dialogtest(SpeichernDlg)
            SpeichernDlg.Cancel
           Kontext "CreateNewAdabasDatabase"
            TransactionlogBtn.Click
           Kontext "SpeichernDlg"
            call Dialogtest(SpeichernDlg)
            SpeichernDlg.Cancel
           Kontext "CreateNewAdabasDatabase"
            DataDevSpaceBtn.Click
           Kontext "SpeichernDlg"
            call Dialogtest(SpeichernDlg)
            SpeichernDlg.Cancel
           Kontext "CreateNewAdabasDatabase"
            CreateNewAdabasDatabase.Cancel
         catch
        warnlog "The ADABAS variables exiting but Adabas Database does not work!"
       endcatch
      end if
  end if
  
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabODBC
 Kontext "TabODBC"
  call Dialogtest(TabODBC)
  ListCountA = Adabas_CharacterSet.GetItemCount
  if ListCountA <> 53 then
      warnlog "There should be 53 character sets available but there are " & ListCountA & " sets available!?"
  end if  
  Kontext "DataSourceAdministration"
  TabControl.SetPage TabAdabasStatistics
 '  TabControl.SetPageId(19213)
  sleep(2)
 Kontext "TabAdabasStatistics"
  call Dialogtest(TabAdabasStatistics)
  Extended.Click
  sleep(4)
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
   if MessageBox.GetRT = 376 then
    Messagebox.OK
   end if
  end if
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabAdabasUserSettings
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
   if MessageBox.GetRT = 376 then
    Messagebox.OK
   end if
  end if
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase
'-------------------------------------------------------------------------

testcase tTabJDBC 
 printlog "tab page JDBC"
  call hNewDocument
  '/// Tools / Data Sources
  ToolsDataSources
 Kontext "DataSourceAdministration"
  '/// Clicking on <i>New Data Source</i>
  NewDataSource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  '/// Selecting 1st entry of platform is<ul><li>Solaris x86</li><li>OS/2</li><li>MacOS</li></ul>
  if gPlatform = "x86" OR gPlatform = "os2" OR gPlatform = "os4" OR gPlatform = "mac" then
    DatabaseType.Select(2)
   else
    '/// Selecting 3th entry for all other platforms.
    DatabaseType.Select(3)
  end if
 Kontext "DataSourceAdministration"
  '/// Verifying that tabpage <i>JDBC</i> is selectable.
  TabControl.SetPage TabJDBC
 Kontext "TabJDBC"
  call Dialogtest(TabJDBC)
  Kontext "DataSourceAdministration"
  '/// Cancel <i>Data Source Administration</i>-dialog.
  DataSourceAdministration.Cancel
  call hCloseDocument
endcase

'-------------------------------------------------------------------------
testcase tTabODBC
 Dim ListCountA as integer
 dim i as integer 
 '/// Description ///'
 printlog "tab page ODBC"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  NewDataSource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
   if gPlatform = "x86" OR gPlatform = "os2" OR gPlatform = "os4" OR gPlatform = "mac" then
    DatabaseType.Select(3)
   else
    '/// Selecting 3th entry for all other platforms.
    DatabaseType.Select(4)
  end if  
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabODBC
 Kontext "TabODBC"
  call Dialogtest(TabODBC)
  ListCountA = CharacterSet.GetItemCount  
  if ListCountA <> 53 then
    warnlog "There should be 53 character sets available but there are " & ListCountA & " sets available!?"
  end if  
  for i = 1 to ListCountA
        printlog CharacterSet.GetItemText(i)
        select case i
            case 1:
                if Instr(CharacterSet.GetItemText(i),"System") = 0 then warnlog "The character set isn't right"
            case 2:            
                if Instr(CharacterSet.GetItemText(i),"(Windows-1252/WinLatin 1)") = 0 then warnlog "The character set isn't right"
            case 3:    
                if Instr(CharacterSet.GetItemText(i),"(Apple Macintosh)") = 0 then warnlog "The character set isn't right"
            case 4:   
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-437/US)") = 0 then warnlog "The character set isn't right"
            case 5:  
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-850/") = 0 then warnlog "The character set isn't right"
            case 6: 
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-860/") = 0 then warnlog "The character set isn't right"
            case 7:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-861/") = 0 then warnlog "The character set isn't right"
            case 8:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-863/") = 0 then warnlog "The character set isn't right"
            case 9:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-865/") = 0 then warnlog "The character set isn't right"
            case 10:
                if Instr(CharacterSet.GetItemText(i),"(ASCII/US)") = 0 then warnlog "The character set isn't right"
            case 11:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-1)") = 0 then warnlog "The character set isn't right"
            case 12:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-2)") = 0 then warnlog "The character set isn't right"
            case 13:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-3)") = 0 then warnlog "The character set isn't right"
            case 14:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-4)") = 0 then warnlog "The character set isn't right"
            case 15:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-5)") = 0 then warnlog "The character set isn't right"
            case 16:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-6)") = 0 then warnlog "The character set isn't right"
            case 17:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-7)") = 0 then warnlog "The character set isn't right"
            case 18:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-8)") = 0 then warnlog "The character set isn't right"
            case 19:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-9)") = 0 then warnlog "The character set isn't right"
            case 20:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-14)") = 0 then warnlog "The character set isn't right"
            case 21:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-15/EURO)") = 0 then warnlog "The character set isn't right"
            case 22:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-852)") = 0 then warnlog "The character set isn't right"
            case 23:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-862)") = 0 then warnlog "The character set isn't right"
            case 24:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-864)") = 0 then warnlog "The character set isn't right"
            case 25:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-866/") = 0 then warnlog "The character set isn't right"
            case 26:
                if Instr(CharacterSet.GetItemText(i),"(Windows-874)") = 0 then warnlog "The character set isn't right"
            case 27:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1250/WinLatin 2)") = 0 then warnlog "The character set isn't right"
            case 28:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1251)") = 0 then warnlog "The character set isn't right"
            case 29:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1253)") = 0 then warnlog "The character set isn't right"
            case 30:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1254)") = 0 then warnlog "The character set isn't right"
            case 31:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1255)") = 0 then warnlog "The character set isn't right"                           
            case 32:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1256)") = 0 then warnlog "The character set isn't right"                           
            case 33:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1257)") = 0 then warnlog "The character set isn't right"
            case 34:
                if Instr(CharacterSet.GetItemText(i),"(Shift-JIS)") = 0 then warnlog "The character set isn't right"                           
            case 35:
                if Instr(CharacterSet.GetItemText(i),"(GB-2312)") = 0 then warnlog "The character set isn't right"
            case 36:
                if Instr(CharacterSet.GetItemText(i),"(GBT-12345)") = 0 then warnlog "The character set isn't right"                           
            case 37:
                if Instr(CharacterSet.GetItemText(i),"(GBK/GB-2312-80)") = 0 then warnlog "The character set isn't right"
            case 38:
                if Instr(CharacterSet.GetItemText(i),"(Big5)") = 0 then warnlog "The character set isn't right"                           
            case 39:
                if Instr(CharacterSet.GetItemText(i),"(EUC-JP)") = 0 then warnlog "The character set isn't right"
            case 40:
                if Instr(CharacterSet.GetItemText(i),"(ISO-2022-JP)") = 0 then warnlog "The character set isn't right"                           
            case 41:
                if Instr(CharacterSet.GetItemText(i),"(ISO-2022-CN)") = 0 then warnlog "The character set isn't right"
            case 42:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-R)") = 0 then warnlog "The character set isn't right"                           
            case 43:
                if Instr(CharacterSet.GetItemText(i),"(UTF-7)") = 0 then warnlog "The character set isn't right"
            case 44:
                if Instr(CharacterSet.GetItemText(i),"(UTF-8)") = 0 then warnlog "The character set isn't right"                           
            case 45:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-10)") = 0 then warnlog "The character set isn't right"
            case 46:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-13)") = 0 then warnlog "The character set isn't right"                           
            case 47:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-U)") = 0 then warnlog "The character set isn't right"
            case 48:
                if Instr(CharacterSet.GetItemText(i),"(ISO-2022-KR)") = 0 then warnlog "The character set isn't right"                           
            case 49:
                if Instr(CharacterSet.GetItemText(i),"(Windows-Johab-1361)") = 0 then warnlog "The character set isn't right"
            case 50:
                if Instr(CharacterSet.GetItemText(i),"(GB-18030)") = 0 then warnlog "The character set isn't right"                           
            case 51:
                if Instr(CharacterSet.GetItemText(i),"(BIG5-HKSCS)") = 0 then warnlog "The character set isn't right"
            case 52:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-11/TIS-620)") = 0 then warnlog "The character set isn't right"
            case 53:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-U)") = 0 then warnlog "The character set isn't right"
        end select      
  next  
  
  Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabdBase
 Dim b as integer
 Dim ListCountA as integer
 dim i as integer
 '/// Description ///'
 printlog "tab page dBase"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  NewDatasource.Click
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatform <> "os2" AND gPlatform <> "x86" AND gPlatform <> "os4" AND gPlatform <> "mac" then
    DatabaseType.Select(5)
   else
    DatabaseType.Select(4)
  end if
 Kontext "DataSourceAdministration"
  TabCOntrol.SetPage TabdBase
  for b= 1 to 2
   Kontext "Messagebox"
    if Messagebox.Exists(3) then
     if MessageBox.GetRT = 304 then
      if b = 2 then
       warnlog Messagebox.GetText
       warnlog "Why asking to times?"
      end if
      Messagebox.No
     end if
    end if
  next b
 Kontext "TabdBase"
  call Dialogtest(TabdBase)
  ListCountA = CharacterSet.GetItemCount
  if ListCountA <> 38 then
    warnlog "There should be 38 character sets available but there are " & ListCountA & " sets available!?"
  end if
  
  for i = 1 to ListCountA
        printlog CharacterSet.GetItemText(i)
        select case i
            case 1:
                if Instr(CharacterSet.GetItemText(i),"System") = 0 then warnlog "The character set isn't right"
            case 2:            
                if Instr(CharacterSet.GetItemText(i),"(Windows-1252/WinLatin 1)") = 0 then warnlog "The character set isn't right"
            case 3:    
                if Instr(CharacterSet.GetItemText(i),"(Apple Macintosh)") = 0 then warnlog "The character set isn't right"
            case 4:   
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-437/US)") = 0 then warnlog "The character set isn't right"
            case 5:  
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-850/") = 0 then warnlog "The character set isn't right"
            case 6: 
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-860/") = 0 then warnlog "The character set isn't right"
            case 7:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-861/") = 0 then warnlog "The character set isn't right"
            case 8:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-863/") = 0 then warnlog "The character set isn't right"
            case 9:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-865/") = 0 then warnlog "The character set isn't right"
            case 10:
                if Instr(CharacterSet.GetItemText(i),"(ASCII/US)") = 0 then warnlog "The character set isn't right"
            case 11:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-1)") = 0 then warnlog "The character set isn't right"
            case 12:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-2)") = 0 then warnlog "The character set isn't right"
            case 13:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-3)") = 0 then warnlog "The character set isn't right"
            case 14:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-4)") = 0 then warnlog "The character set isn't right"
            case 15:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-5)") = 0 then warnlog "The character set isn't right"
            case 16:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-6)") = 0 then warnlog "The character set isn't right"            
            case 17:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-7)") = 0 then warnlog "The character set isn't right"
            case 18:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-8)") = 0 then warnlog "The character set isn't right"            
            case 19:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-9)") = 0 then warnlog "The character set isn't right"            
            case 20:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-14)") = 0 then warnlog "The character set isn't right"
            case 21:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-15/EURO)") = 0 then warnlog "The character set isn't right"
            case 22:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-852)") = 0 then warnlog "The character set isn't right"
            case 23:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-862)") = 0 then warnlog "The character set isn't right"
            case 24:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-864)") = 0 then warnlog "The character set isn't right"
            case 25:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-866/") = 0 then warnlog "The character set isn't right"
            case 26:
                if Instr(CharacterSet.GetItemText(i),"(Windows-874)") = 0 then warnlog "The character set isn't right"
            case 27:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1250/WinLatin 2)") = 0 then warnlog "The character set isn't right"
            case 28:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1251)") = 0 then warnlog "The character set isn't right"
            case 29:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1253)") = 0 then warnlog "The character set isn't right"
            case 30:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1254)") = 0 then warnlog "The character set isn't right"
            case 31:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1255)") = 0 then warnlog "The character set isn't right"
            case 32:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1256)") = 0 then warnlog "The character set isn't right"
            case 33:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1257)") = 0 then warnlog "The character set isn't right"
            case 34:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-R)") = 0 then warnlog "The character set isn't right"
            case 35:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-10)") = 0 then warnlog "The character set isn't right"
            case 36:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-13)") = 0 then warnlog "The character set isn't right"
            case 37:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-11/TIS-620)") = 0 then warnlog "The character set isn't right"
            case 38:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-U)") = 0 then warnlog "The character set isn't right"    
        end select      
  next
 
  Indexes.Click
 Kontext "Indexes"
  call Dialogtest(Indexes)
  Indexes.Cancel
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabADO
 '/// Description ///'
 printlog "tab page ADO"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  DatabaseType.Select(6)
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabADO
 Kontext "TabADO"
  call Dialogtest(TabADO)
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabTEXTBase
 Dim b as integer
 Dim ListCountA as integer
 Dim ListCountB as integer
 Dim ListCountC as integer
 Dim ListCountD as integer
 Dim ListCountE as integer
 Dim ListCountF as integer
 dim i as integer
 '/// Description ///'
 printlog "tab page TextBase"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  NewDatasource.Click
  TabCOntrol.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatgroup = "w95" then
    DatabaseType.Select(7)
   else
    if gPlatform <> "os2" AND gPlatform <> "x86" AND gPlatform <> "os4" AND gPlatform <> "mac" then
      DatabaseType.Select(6)
     else
      DatabaseType.Select(5)
    end if
  end if
 Kontext "DataSourceAdministration"
  TabControl.SetPage TabTextBase
  for b= 1 to 2
   Kontext "Messagebox"
    if Messagebox.Exists(3) then
     if MessageBox.GetRT = 304 then
      if b = 2 then
       warnlog Messagebox.GetText
       warnlog "Why asking to times?"
      end if
      Messagebox.No
     end if
   end if
  next b
 Kontext "TabTextBase"
  call Dialogtest(TabTextBase)
  '/// Field separator ///'
  ListCountA = FieldSeparator.GetItemCount
  if ListCountA <> 5 then
    warnlog "There should be 5 field separators available but there are " & ListCountA & " separators available!?"
  end if
  '/// Text separator ///'
  ListCountB = TextSeparator.GetItemCount
  if ListCountB <> 3 then
    warnlog "There should be 3 text separators available but there are " & ListCountB & " separators available!?"
  end if
  '/// Decimal separator ///'
  ListCountC = DecimalSeparator.GetItemCount
  if ListCountC <> 4 then
    warnlog "There should be 4 decimal separators available but there are " & ListCountC & " separators available!?"
  end if
  '/// Thousands separator ///'
  ListCountD = ThousandsSeparator.GetItemCount
  if ListCountD <> 2 then
    warnlog "There should be 2 thousands separators available but there are " & ListCountD & " separators available!?"
  end if
  '/// Extensions ///'
  ListCountE = Extension.GetItemCount
  if ListCountE <> 3 then
    warnlog "There should be 3 extensions available but there are " & ListCountE & " extensions available!?"
  end if
  '/// Character set ///'
  ListCountF = CharacterSet.GetItemCount
  if ListCountF <> 38 then
    warnlog "There should be 38 character sets available but there are " & ListCountF & " sets available!?"
  end if
  
  for i = 1 to ListCountF
        printlog CharacterSet.GetItemText(i)
        select case i
            case 1:
                if Instr(CharacterSet.GetItemText(i),"System") = 0 then warnlog "The character set isn't right"
            case 2:            
                if Instr(CharacterSet.GetItemText(i),"(Windows-1252/WinLatin 1)") = 0 then warnlog "The character set isn't right"
            case 3:    
                if Instr(CharacterSet.GetItemText(i),"(Apple Macintosh)") = 0 then warnlog "The character set isn't right"
            case 4:   
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-437/US)") = 0 then warnlog "The character set isn't right"
            case 5:  
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-850/") = 0 then warnlog "The character set isn't right"
            case 6: 
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-860/") = 0 then warnlog "The character set isn't right"
            case 7:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-861/") = 0 then warnlog "The character set isn't right"
            case 8:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-863/") = 0 then warnlog "The character set isn't right"
            case 9:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-865/") = 0 then warnlog "The character set isn't right"
            case 10:
                if Instr(CharacterSet.GetItemText(i),"(ASCII/US)") = 0 then warnlog "The character set isn't right"
            case 11:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-1)") = 0 then warnlog "The character set isn't right"
            case 12:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-2)") = 0 then warnlog "The character set isn't right"
            case 13:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-3)") = 0 then warnlog "The character set isn't right"
            case 14:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-4)") = 0 then warnlog "The character set isn't right"
            case 15:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-5)") = 0 then warnlog "The character set isn't right"
            case 16:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-6)") = 0 then warnlog "The character set isn't right"            
            case 17:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-7)") = 0 then warnlog "The character set isn't right"
            case 18:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-8)") = 0 then warnlog "The character set isn't right"            
            case 19:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-9)") = 0 then warnlog "The character set isn't right"            
            case 20:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-14)") = 0 then warnlog "The character set isn't right"
            case 21:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-15/EURO)") = 0 then warnlog "The character set isn't right"
            case 22:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-852)") = 0 then warnlog "The character set isn't right"
            case 23:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-862)") = 0 then warnlog "The character set isn't right"
            case 24:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-864)") = 0 then warnlog "The character set isn't right"
            case 25:
                if Instr(CharacterSet.GetItemText(i),"(DOS/OS2-866/") = 0 then warnlog "The character set isn't right"
            case 26:
                if Instr(CharacterSet.GetItemText(i),"(Windows-874)") = 0 then warnlog "The character set isn't right"
            case 27:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1250/WinLatin 2)") = 0 then warnlog "The character set isn't right"
            case 28:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1251)") = 0 then warnlog "The character set isn't right"
            case 29:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1253)") = 0 then warnlog "The character set isn't right"
            case 30:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1254)") = 0 then warnlog "The character set isn't right"
            case 31:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1255)") = 0 then warnlog "The character set isn't right"
            case 32:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1256)") = 0 then warnlog "The character set isn't right"
            case 33:
                if Instr(CharacterSet.GetItemText(i),"(Windows-1257)") = 0 then warnlog "The character set isn't right"
            case 34:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-R)") = 0 then warnlog "The character set isn't right"
            case 35:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-10)") = 0 then warnlog "The character set isn't right"
            case 36:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-13)") = 0 then warnlog "The character set isn't right"
            case 37:
                if Instr(CharacterSet.GetItemText(i),"(ISO-8859-11/TIS-620)") = 0 then warnlog "The character set isn't right"
            case 38:
                if Instr(CharacterSet.GetItemText(i),"(KOI8-U)") = 0 then warnlog "The character set isn't right"    
        end select      
  next  

 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------
testcase tTabSpreadsheet
 Dim CountOfPages as integer
 printlog "tab page Spreadsheet"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatgroup = "w95" then
    DatabaseType.Select(8)
   else
    if gPlatform <> "os2" AND gPlatform <> "x86" AND gPlatform <> "os4" AND gPlatform <> "mac" then
      DatabaseType.Select(7)
     else
      DatabaseType.Select(6)
    end if
  end if
 Kontext "DataSourceAdministration"
  CountOfPages = TabControl.GetPageCount
  printlog "Page count: " & CountOfPages
  if CountOfPages <> 4 then
       warnlog "There are not 4 tab pagesavailable! Bug!"
  end if
 Kontext "TabGeneral"
  SelectPath.Click
 Kontext "OeffnenDlg"
  call Dialogtest(OeffnenDlg)
  OeffnenDlg.Cancel
  sleep(1)
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase
