'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: id_001.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:19 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* Owner : thorsten.bosbach@sun.com
'*
'* short description :
'*
'***********************************************************************************
' #1 tiFileSaveAs
' #1 tiFileReload (sFileIn as string)
' #1 tiFileVersion (sFileIn as string)
' #1 tiFilePassword (sFileIn as string)
' #1 tiFileTemplates
' #1 tiFilePrint
' #1 tmFileNewFromTemplate
' #1 tmFileOpen
' #1 tmFileClose
' #1 tmFileSave
' #1 tmFileSaveAs
' #1 tmFileSaveAll
' #1 tmFileSendDocumentAsPDF
' #1 tmFileExportAsPDF
' #1 tmExportAsPDF
' #1 tmFileProperties
' #1 tmFilePrinterSetting
' #1 tmFileExit
'\**********************************************************************************

'/// used Documents ///'
'///"graphics\update\input\tbo_alf_.sx?" ///

sub id_001
   printLog Chr(13) + "---------    id_001    ----------"

   call tiFileSaveAs
   call tiFileReload ("user/work/graphics/update/version1.sx"+left(lcase(gApplication),1))
   call tiFileVersion ("user/work/graphics/update/erwin.sx"+left(lcase(gApplication),1))
   printlog " File->Send not possible to test, because extrnal prg get's called!"
   call tiFileTemplates
   call tiFilePrint
'   Call tiFileNew instead i call:
   call tmFileNewFromTemplate
   call tmFileOpen
   call tmFileClose
   call tmFileSave
   call tmFileSaveAs
   call tmFileSaveAll
   Call tmFileSendDocumentAsPDF
   Call tmFileExportAsPDF ' not realy here !
   Call tmExportAsPDF
   call tmFileProperties
   call tmFilePrinterSetting
' special cases
   call tiFilePassword ("user/work/graphics/update/erwin.sxd")
'   Call AutoPilot      'inc\desktop\autopilo.inc
   call tmFileExit
end sub

testcase tiFileSaveAs
   dim sFileName as string ' test document & new created doc
'   dim sFormula as string  ' container for formula to create document with
   dim sTemp as string
   dim sFilter (50) as string
   dim i,x,y as integer
   dim Exlist(100) as string ' files to be deleted
   dim sFile, sPath as string ' filename and path to export


   sFilter (0) = 0 ' initalize ;-)...

'/// used document: "graphics\update\input\tbo_alf_.sx?" ///
   sFileName = "graphics\update\input\tbo_alf_.sx" + left(Lcase(gApplication),1)         ' this is the file with all features
   sFile = "isas_"                                ' this is the filename of the export files
   sPath = ConvertPath ( gOfficePath + "user/work/graphics/update/"+Lcase(gApplication)+"\"+ gPlatform) ' this is the export path
   if dir (sPath) = "" then app.mkdir (sPath)

  Printlog "'/// deleting all files in output directory: \\user\\work\\graphics\\update\\Lcase(gApplication) gPlatform isas_* ///'"
   if gSamePC = TRUE then ' delete export directory
      GetFileList ( sPath, sFile+"*", Exlist() )
      if KillFileList ( Exlist() ) <> TRUE then
         Warnlog "Couldn't delete all Files in Output-Export-Directory, the followings are still there:"
         for i=1 to ListCount ( Exlist() )
            printlog "  <> " + Exlist(i)
         next i
      end if
   end if

'///  load a sample presentation file  ///'
   Call hDateiOeffnen ( ConvertPath(gTesttoolPath + sFileName) )
   sleep 3

'/// start loop 5 times for: ///'
'///    - StarImpress 5.0 ///
'///    - StarOffice 6.0 Presentation ///
'///    - StarOffice 6.0 Presentation Template ///
'///    - Microsoft PowerPoint 97/2000/XP Template ///
'///    - StarOffice 6.0 Drawing (StarOffice Impress) ///
'/// to be language independant, select first, second last,... and last filter from list -> but trie to check the names :-) ///'

' to use the helper fileSaveAs functions i get alll available filters...
   FileSaveAs
   sleep 2
   Kontext "SpeichernDlg"
   for i = 0 to 5
      if i=0 then x = Dateityp.GetItemCount
      if (i) then  ' set border, whenm start from beginning/end
         y = i     ' set filter from beginning
      else
         y = x-3     ' set filter from end
      endif
      ListAppend(sFilter(), Dateityp.GetItemText (y))
   next i
   SpeichernDlg.Cancel

   y = ListCount(sFilter())
   for i = 1 to y
      sFileName = sPath + sFile + (i)
      hSpeichernUnterMitFilter (sFileName, sFilter(i), TRUE )
   '/// file save with filter as: "graphics\update\output\\math\\fsas_[0,1,2,...]" ///'
      printlog " saved with filter ("+i+"/"+y+"): "+ sFilter(i)
   next i
' TODO TBO: small check, if correct filter was used!
   sleep 3
   fileclose
   sleep 3
   kontext "Messagebox"
   if Messagebox.exists then
      printlog "Messagebox about informationloss... :-) that's OK: '"+Messagebox.GetText+"'"
      Messagebox.yes
   endif

'-----------------------------------------------------------------
'/// Load all saved files ///'
   hNewDocument

'/// a small loop, to load all files previous saved ///'

   sFilter (0) = 0
'///load documents from  "graphics\update\output\\impress\\fsas_*" ///
   sFileName = sPath
   GetFileList ( sFileName, sFile + "*", sFilter() )

'   call hNewDocument
   x = ListCount ( sFilter() )
   for i = 1 to x
     printlog "("+i+"/"+x+"): "+sFilter(i)
      hDateiOeffnen ( sFilter(i) )
      Sleep 2
      If hIsNamedDocLoaded (sFilter(i)) Then
         printlog "  used filter: " + hGetUsedFilter()
      else
         sTemp = left(right(sFilter(i),2),1)
         printlog "-"+sTemp+"-"+sFilter(i)+"-"
         if ( (sTemp = "t") OR (sTemp = "o") ) then
            printlog "document is --- TEMPLATE?! --- "
         else
            warnlog "document didn't get loaded"
         endif
      endif
      hCloseDocument
      sleep 2
   next i
'   Call hCloseDocument
endcase

testcase tiFileReload (sFileIn as string)
  Dim DokumentPfad$
  Dim Datei$
  Datei$= (ConvertPath (gOfficePath + sFileIn))
'/// open application ///'
   Call hNewDocument
   sleep 2
'/// save document "..." ///'
   Call hSpeichernUnterKill (Datei$)
   sleep 2
'/// close document ///'
   Call hCloseDocument

'/// load document again ///'
   Call hDateiOeffnen (Datei$)
   sleep 2
'/// type something in document ///'
   call hTBOtypeInDoc
   sleep 2
'/// File->Reload ///'
   FileReload
   sleep 2
'/// Messagebox has to come up; say NO ///'
   Kontext "Messagebox"
   sleep 2
   Messagebox.No
   sleep 2

'/// File->Reload ///'
   FileReload
   sleep 2
   Kontext "Messagebox"
   sleep 2
'/// Messagebox has to come up; say YES ///'
   Messagebox.Yes
   sleep 1

'/// close document ///'
   Call hCloseDocument
'/// delete document ///'
   if Dir (Datei$) <> "" AND gSamePC = TRUE then kill Datei$
endcase

testcase tiFileVersion (sFileIn as string)
  Dim DokumentPfad$
  Dim Datei$
  Datei$= (ConvertPath (gOfficePath + sFileIn))

'/// open application ///'
   Call hNewDocument
   sleep 1
'/// save document as "..." ///'
   Call hSpeichernUnterKill ConvertPath (( gOfficePath + sFileIn))
   sleep 1
'/// close document ///'
   Call hCloseDocument

'/// open document again ///'
   Call hDateiOeffnen ConvertPath ( gOfficePath + sFileIn )
   sleep 1
'/// type something in document ///'
   call hTBOtypeInDoc
   sleep 1
'/// File->Versions ///'
   try
      FileVersions
   catch
      Warnlog "- File / Versions not accessible!"
      exit sub
   endcatch

   Kontext "Versionen"
   Call DialogTest ( Versionen )
'/// in Versions dialog press "save" ///'
   Speichern.Click
'/// type a comment ///'
   Kontext "VersionskommentarEingeben"
   Call DialogTest ( VersionskommentarEingeben )
'/// exit comment dialog with cancel ///'
   VersionskommentarEingeben.Cancel
   Kontext "Versionen"
'/// close version dialog ///'
   Versionen.Close
'/// close document ///'
   Call hCloseDocument
'   if Dir (Datei$) <> "" AND gSamePC = TRUE then kill Datei$
endcase

testcase tiFilePassword (sFileIn as string)
   Dim DokumentPfad$
   Dim Datei$
   dim sFileName as string ' test document & new created doc
'   dim sFormula as string  ' container for formula to create document with
   dim sTemp as string
   dim sFilter (50) as string
   dim i,x,y as integer
   dim Exlist(100) as string ' files to be deleted
   dim sFile, sPath as string ' filename and path to export

'///  save file to:  "graphics\update\output\"+Lcase(gApplication)+"\"+ gPlatform+"\"isp__" ///'
   sFile = "isp__"                                                     ' this is the filename of the export files
   sPath = ConvertPath ( gOfficePath + "user/work/graphics/update/"+Lcase(gApplication)+"\"+ gPlatform+"\") ' this is the export path
   if dir (sPath) = "" then app.mkdir (sPath)
   sFileIn = sPath + sFile + ".sx"+left (Lcase(gApplication),1)

   Printlog "'/// deleting all files in output directory: \\graphics\update\output\\impress\\ gPlatform isp_* ///'"
   if gSamePC = TRUE then ' delete export directory
      GetFileList ( sPath, sFile+"*", Exlist() )
      if KillFileList ( Exlist() ) <> TRUE then
         Warnlog "Couldnt delete all Files in Output-Export-Directory, the followings are still there:"
         for i=1 to ListCount ( Exlist() )
            printlog "  <> " + Exlist(i)
         next i
      end if
   end if

'/// open application ///'
   Call hNewDocument
   sleep 1
'/// File->SaveAs ///'
   FileSaveAs
      Kontext "SpeichernDlg"
      Datei$ = ConvertPath ( sFileIn )
      printlog "   will use the file: "+Datei$
      if Dir (Datei$) <> "" then
         kill Datei$
      endif
      sleep 1
      '/// check 'password' ///'
      Passwort.Check
      '/// set 'filename' ///'
      Dateiname.SetText Datei$
      '/// press 'save' ///'
      Speichern.Click
   Sleep 2
   Kontext "Messagebox"
      '/// (if messagebox comes up, say YES) ///'
      if Messagebox.Exists (1) then Messagebox.Yes
   Sleep 2
   Kontext "Passwort"
      PasswortName.SetText "12345"
      PasswortBestaetigen.Settext "54321"
      '/// type password "12345", confirm password: "54321" -> WRONG ///'
      Passwort.OK
   sleep 2
   Kontext "Messagebox"
      '/// messagebox has to show up, say OK, if messagebox doesnt come up -> ERROR ///'
      if Messagebox.Exists(1) then
         Messagebox.OK
      else
         Warnlog "- Wrong password not recognized"
      end if
   Kontext "Passwort"
      '/// type password "12345", confirm password: "12345" -> RIGHT ///'
      PasswortName.SetText "12345"
      PasswortBestaetigen.SetText "12345"
      Passwort.OK
      '/// close document ///'
      sleep 2
   FileClose
   sleep 2

   '/// open document ///'
   FileOpen
      Kontext "OeffnenDlg"
      sleep 2
      Dateiname.SetText Datei$
      Oeffnen.Click
   sleep 2
   Kontext "PasswordFileOpen"
      '/// type password: "34567" -> WRONG ///'
      PasswortName.SetText "34567"
      try
         PasswordFileOpen.OK
      catch
         Printlog "- Wrong password not accepted"
      endcatch
   Kontext
   '/// messagebox has to show up, say OK, if messagebox doesn't come up -> ERROR ///'
      if Not Messagebox.Exists(1) then
         Warnlog "Wrong password while loading not recognized"
      else
         Messagebox.OK
         printlog "Wrong password on loading ok - recogniced"
      end if
   sleep 3
   '/// open document ///'
   hDateiOeffnen(Datei$)
   Kontext "PasswordFileOpen"
      sleep 2
      '/// type password: "12345" -> RIGHT ///'
      PasswortName.SetText "12345"
      PasswordFileOpen.OK
   sleep 5
   '/// File->SaveAs ///'
   FileSaveAs
      Kontext "SpeichernDlg"
      Dateiname.SetText Datei$
      if (Passwort.IsChecked <> TRUE) then
         Warnlog "Password has to be checked! :-("
      endif
      '/// press 'save', without changing any checkbox! -> file has to be saved WITH password protection ///'
      Speichern.Click
      sleep 1
   Kontext "Messagebox"
      '/// (if messagebox comes up, say YES) ///'
      if Messagebox.Exists(2) then
         Messagebox.Yes
      endif
      '/// password dialog has to show up! ///'
   Kontext "Passwort"
      if (Passwort.Exists(5) = FALSE)then
         Warnlog "- Password dialog Didn't pop up after pressing save"
      else
         Kontext "Passwort"
         '/// type password "a12345", confirm password: "a12345" -> RIGHT ///'
    sleep 1
         PasswortName.SetText "a12345"
         PasswortBestaetigen.SetText "a12345"
         Passwort.OK
         sleep 2
         '/// close document ///'
         FileClose
         sleep 1
      endif
   '/// open document ///'
   FileOpen
      sleep 2
      Kontext "OeffnenDlg"
      Dateiname.SetText Datei$
      Oeffnen.Click
      Kontext "PasswordFileOpen"
      sleep 1
      '/// type password: "a12345" -> RIGHT ///'
      PasswortName.SetText "a12345"
      PasswordFileOpen.OK
      sleep 5
   '/// File->SaveAs ///'
   FileSaveAs
      Kontext "SpeichernDlg"
      Dateiname.SetText Datei$
      if (Passwort.IsChecked <> TRUE) then
         Warnlog "Password has to be checked! :-("
      endif
      Passwort.UnCheck
      '/// press 'save', without changing any checkbox! -> file has to be saved WITH password protection ///'
      Speichern.Click
   Kontext "Messagebox"
      '/// (if messagebox comes up, say YES) ///'
      if Messagebox.Exists(2) then Messagebox.Yes
   '/// password dialog needn't to show up! ///'
   Kontext "Passwort"
      if (Passwort.Exists(5))then
         Warnlog "- Password dialog didn't pop up after pressing save"
         Kontext "Passwort"
         password.cancel
         '/// close document ///'
         FileClose
      else
         '/// close document ///'
         hCloseDocument
      end if
endcase

testcase tiFileTemplates
   Call hNewDocument

   FileTemplatesOrganize
      Kontext "DVVerwalten"
      sleep 1
      Call DialogTest (DVVerwalten)
      sleep 1
      PopuplisteLinks.Select 2
      sleep 1
      PopuplisteRechts.Select 2
      sleep 1
      WelcheDatei.Click
      sleep 1
         Kontext "Oeffnendlg"
         Call DialogTest (OeffnenDlg)
         sleep 1
      OeffnenDlg.Cancel
      sleep 2
      Kontext "DVVerwalten"
   DVVerwalten.Close

   FileTemplatesAddressBookSource
     Printlog "- AddressBookAssignment"
      kontext "AddressBookSource"
      Call DialogTest (AddressBookSource)
      Administrate.Click
         kontext "DataSourceAdministration"
      DataSourceAdministration.Cancel
      ' plan b Messagebox, cancel settab tabgeneral, cancel
      kontext "AddressBookSource"
   AddressBookSource.Cancel


   FileTemplatesSave
     Printlog "- Save template"
      sleep 1
      Kontext "Dokumentvorlagen"
      sleep 1
      Call DialogTest (Dokumentvorlagen)
      sleep 1
      Verwalten.Click
         sleep 2
         Kontext "DVVerwalten"
         Call DialogTest (DVVerwalten)
         sleep 3
      DVVerwalten.Close
      sleep 1
      Kontext "Dokumentvorlagen"
      sleep 1
   Dokumentvorlagen.Cancel
   sleep 1

   try
      FileTemplatesEdit
         Printlog "- Edit template"
         sleep 1
         Kontext "OeffnenDlg"
         sleep 1
         Call DialogTest (OeffnenDlg)
         sleep 1
      OeffnenDlg.Cancel
   catch
      Warnlog "- There are problems with File-Template-Save"
   endcatch
   sleep 1
   Call hCloseDocument
endcase

testcase tiFilePrint
   Call hNewDocument
'/// open application ///'
'/// File->Print ///'
   FilePrint
   sleep 1
   Kontext "DruckenDlg"
   Call DialogTest (DruckenDlg)
'/// click 'options' ///'
   sleep 2
   Zusaetze.Click

   Kontext "DruckerZusaetzeDraw"
   Call DialogTest (DruckerZusaetzeDraw)
   DruckerZusaetzeDraw.Cancel
'/// close options dialog with 'cancel' ///'
   Kontext "DruckenDlg"
'/// close print dialog with 'cancel' ///'
   DruckenDlg.Cancel
   sleep (2)
'/// close application ///'
   Call hCloseDocument
endcase


'-----------------------------------------------------------
'*******************  M A T H dito *************************
'-----------------------------------------------------------


testcase tmFileNewFromTemplate
   Call hNewDocument
   FileNewFromTemplate
  '/// Open dialog with File / New / From Template ///
   sleep (5)
  Kontext "TemplateAndDocuments"
  '/// Check if dialog has been opened ///
  if TemplateAndDocuments.NotExists then
     Warnlog "Dialog Templates and Documents are not up!"
     exit sub
  endif
   Call DialogTest (TemplateAndDocuments)
   sleep 5
   try
      TemplateAndDocuments.Cancel
   catch
   endcatch
   sleep 5
   Call hCloseDocument
endcase

testcase tmFileOpen
   call hNewDocument
   FileOpen
      Kontext "OeffnenDlg"
      UebergeordneterOrdner.Click
      Standard.Click
      NurLesen.check
      Call DialogTest ( OeffnenDlg )
   OeffnenDlg.Cancel
   Sleep 2
   Call hCloseDocument
endcase

testcase tmFileClose
   printlog "- File Close"
   hNewDocument    ' just for the records: I open ONE document
   call hTBOtypeInDoc
   sleep (2)
   FileClose
   Kontext         ' Expecting "Modified, do you want to close?"
   if active.exists (5) then
      printlog "  Ok, active came up: " + active.gettext
      Active.Cancel   ' No, not this time
   else
      warnlog "active missing (1)"
   endif
      sleep (2)

   FileClose
   Kontext
   Active.Yes      ' but now - records: this document is closed
   sleep (2)

   Kontext "SpeichernDlg"
   Call DialogTest ( SpeichernDlg )
   SpeichernDlg.Cancel
   sleep (2)

   FileClose       ' now the office gets closed! (if there were no modifications!)
   Kontext
   Active.No
   sleep (2)
endcase
'-----------------------------------------------------------
testcase tmFileSave
   hNewDocument
   call hTBOtypeInDoc

   FileSave
   sleep 2
   Kontext "SpeichernDlg"
   UebergeordneterOrdner.click
   Standard.Click
'      NeuerOrdner.Click
'      DateiAuswahl.TypeKeys "Hello<Return>"
'      DateiLoeschen
'      Kontext "Messagebox"
'      MessageBox.Yes
   Call DialogTest (SpeichernDlg)
   Kontext "SpeichernDlg"
   Standard.Click
   SpeichernDlg.Cancel
    sleep 2
   Call hCloseDocument
endcase

testcase tmFileSaveAs

   hNewDocument
   sleep (2)
   call hTBOtypeInDoc

   FileSaveAs
   sleep 1
   Kontext "SpeichernDlg"
   if (SpeichernDlg.exists (5) = FALSE) then
      warnlog "FileSaveAs dialog is not visible"
   endif
   sleep 2
   Passwort.check
   Passwort.uncheck
   AutomatischeDateinamenserweiterung.check
   AutomatischeDateinamenserweiterung.uncheck
   UebergeordneterOrdner.click
   Standard.Click

   NeuerOrdner.click
      kontext "NeuerOrdner"
      neuerordner.cancel
   Kontext "SpeichernDlg"

   Call DialogTest (SpeichernDlg)

   Kontext "SpeichernDlg"
   SpeichernDlg.Cancel
   sleep (2)
   Call hCloseDocument
endcase

testcase tmFileSaveAll
   printlog "- File SaveAll"

   hNewDocument
   call hTBOtypeInDoc

   Printlog "  open 2. window"
   hNewDocument
   call hTBOtypeInDoc

   Printlog "  call save all"
   FileSaveAll
   Printlog "  cancel 1. save"
   Kontext "SpeichernDlg"
   SpeichernDlg.Cancel

   Printlog "  cancel 2. save"
   Sleep 2
   Kontext "SpeichernDlg"
   SpeichernDlg.Cancel
   Sleep 2

   try
      Kontext "SpeichernDlg"
      SpeichernDlg.Cancel
      printlog "smth had been typed in the starting window (just a hint ;-) )"
   catch
      printlog "--------- no other window wants to get saved. :-)"
   endcatch

   Sleep 2
   Printlog "  hCloseDocument both"
   Call hCloseDocument
   sleep 2
   Printlog "  first closed"
   Call hCloseDocument
   sleep 1
   Printlog "  second closed"
   sleep (5)
endcase

testcase tmFileExportAsPDF
   dim sPDF as string
   dim sTemp as string

   sPDF = "PDF - Portable Document Format"

   '/// open application ///'
   Call hNewDocument

   call hTBOtypeInDoc
   '/// File->Export As PDF... ///'
   FileExportAsPDF
      ' the "Export as PDF" dialog has to come up, with the only "File type" "PDF - Portable Document Format"
      kontext "ExportAsPDFDlg"
      sTemp = Dateityp.GetSelText
      if (sTemp <> sPDF) then
         Warnlog "filter for PDF export is missing :-( '" + sPDF + "'"
      endif
      '/// set Textbox "File name" to "abc" ///'
      Dateiname.SetText "abc"
      '/// uncheck the checkbox 'Automatic file name extension' ///'
      AutomatischeDateinamenserweiterung.UnCheck
      '--33013: CHECKBOX: Selection   HID_FILESAVE_SELECTION
      '/// check if Checkbox 'Selection' is disabled, it HAS to! ///'
      if Selektion.IsEnabled then
         Warnlog "Selection is enabled :-("
      endif
      '/// use the cursor keys in the filebrowser ///'
      DateiAuswahl.TypeKeys "<home><down>"
      '/// click on the button "Up one level" ///'
      UebergeordneterOrdner.Click
      '/// click on the button "Create New Directory" ///'
      NeuerOrdner.Click
         kontext "NeuerOrdner"
         '/// in the dialog $Foldername set textfield "New" to "abc" ///'
         OrdnerName.SetText "abc"
         '/// cancel dialog $Foldername ///'
         NeuerOrdner.cancel
      kontext "ExportAsPDFDlg"
      '/// click on the button 'Default Directory' ///'
      Standard.Click
      '/// click on the button 'Export...' ///'
      Export.Click

      ' if file exists, there is a message...
      kontext
      if messagebox.exists then
         messagebox.Yes ' to go on ....
      endif
      kontext "PDFOptions"
    sleep 1
         '/// check radiobutton "All" ///'
         RangeAll.Check
         sleep 1
         '/// check radiobutton "Pages" ///'
    RangePages.Check
         sleep 1
         '/// set textbox '' to "123" ///'
         RangePagesEdit.SetText "123"
         sleep 1
         '/// check radiobutton 'Selection' (not enabled in math!) ///'
         RangeSelection.Check
         sleep 1
         '/// check radiobutton 'Screen optimized (smalest filesize)' ///'
         ScreenOptimized.Check
         sleep 1
         '/// check radiobutton 'Print optimized' ///'
         PrintOptimized.Check
         sleep 1
         '/// check radiobutton 'Press optimized' ///'
         PressOptimized.Check
         sleep 1
         '/// cancel dialog 'PDF Options' ///'
         PDFOptions.Cancel
    sleep 1
   '/// close application ///'
   Call hCloseDocument
endcase

testcase tmFileSendDocumentAsPDF
   '/// open application ///'
   Call hNewDocument

   call hTBOtypeInDoc
   '/// File->Send->Document As PDF Attachment... ///'
   FileSendDocumentAsPDF
   '/// on the dialog 'PDF Options' ///
   kontext "PDFOptions"
      '///+ - check radiobutton 'All' ///'
      RangeAll.Check
      '///+ - check radiobutton 'Pages' ///'
      RangePages.Check
         '///+ - - set textbox '' to '123' ///'
         RangePagesEdit.SetText "123"
      '///+ - check radiobutton 'Selection' (not enabled in math!) ///'
      RangeSelection.Check

      '///+ - check radiobutton 'Screen optimized (smalest filesize)' ///'
      ScreenOptimized.Check
      '///+ - check radiobutton 'Print optimized' ///'
      PrintOptimized.Check
      '///+ - check radiobutton 'Press optimized' ///'
      PressOptimized.Check

      '///+ - cancel dialog 'PDF Options' ///'
      PDFOptions.Cancel

   '/// close application ///'
   Call hCloseDocument
endcase

testcase tmExportAsPDF
   dim sPDF as string
   dim sTemp as string

   sPDF = "PDF - Portable Document Format"

   '/// open application ///'
   Call hNewDocument

   '/// click the button '' on the Functionbar ///'
   kontext "Funktionsleiste"
   ExportAsPDF.click
      ' the 'Export as PDF' dialog has to come up, with the only 'File type' 'PDF - Portable Document Format'
      kontext "ExportAsPDFDlg"
      sTemp = Dateityp.GetSelText
      if (sTemp <> sPDF) then
         Warnlog "filter for PDF export is missing :-( should: '" + sPDF + "'; is: '" +  + "'"
      endif
      '///+ - set Textbox 'File name' to "abc" ///'
      Dateiname.SetText "abc"
      '///+ - uncheck the checkbox 'Automatic file name extension' ///'
      AutomatischeDateinamenserweiterung.UnCheck
      '--33013: CHECKBOX: Selection   HID_FILESAVE_SELECTION
      '/// check if Checkbox 'Selection' is disabled, it HAS to! ///'
      if Selektion.IsEnabled then
         Warnlog "Selection is enabled :-("
      endif
      '///+ - use the cursor keys in the filebrowser ///'
      DateiAuswahl.TypeKeys "<home><down>"
      '///+ - click on the button 'Up one level' ///'
      UebergeordneterOrdner.Click
      '///+ - click on the button 'Create New Directory' ///'
      NeuerOrdner.Click
         kontext "NeuerOrdner"
         '///+ - - in the dialog $Foldername set textfield 'New' to 'abc' ///'
         OrdnerName.SetText "abc"
         '///+ - - cancel dialog $Foldername ///'
         NeuerOrdner.cancel
      kontext "ExportAsPDFDlg"
      '///+ - click on the button 'Default Directory' ///'
      Standard.Click
      '///+ - click on the button 'Export...' ///'
      Export.Click

      ' if file exists, there is a message...
      kontext
      if messagebox.exists then
         messagebox.Yes ' to go on ....
      endif

   '/// close application ///'
   Call hCloseDocument
endcase

testcase tmFileProperties
   printlog "- File Properties"

   Call hNewDocument
   FileProperties

   Kontext
   active.SetPage TabDokument
   Kontext "TabDokument"
   Call DialogTest ( TabDokument )

   Kontext
   active.SetPage TabDokumentInfo
   Kontext "TabDokumentInfo"
   Call DialogTest ( TabDokumentInfo )

   Kontext
   active.SetPage TabBenutzer
   Kontext "TabBenutzer"
   Call DialogTest ( TabBenutzer )
   Infofelder.Click
      Kontext "InfonamenBearbeiten"
      Call DialogTest (InfonamenBearbeiten)
   InfonamenBearbeiten.Cancel

   Kontext
   active.SetPage TabInternet
   Kontext "TabInternet"
   Call DialogTest (TabInternet)
   TabInternet.Cancel
'*TabInternet           HID_DOCINFORELOAD
'DoNotRefreshAutomatically   sfx2:RadioButton:TP_DOCINFORELOAD:RB_NOAUTOUPDATE
'RefreshThisDocument    sfx2:RadioButton:TP_DOCINFORELOAD:RB_RELOADUPDATE
'RedirectFromThisDocument   sfx2:RadioButton:TP_DOCINFORELOAD:RB_FORWARDUPDATE
'TimeReload             sfx2:NumericField:TP_DOCINFORELOAD:ED_RELOAD
'TimeForward            sfx2:NumericField:TP_DOCINFORELOAD:ED_FORWARD
'URL                    sfx2:Edit:TP_DOCINFORELOAD:ED_URL
'BrowseURL              sfx2:PushButton:TP_DOCINFORELOAD:PB_BROWSEURL
'Frame                  sfx2:ComboBox:TP_DOCINFORELOAD:CB_FRAME

   Call hCloseDocument
endcase

testcase tmFilePrinterSetting
   printlog "- File Printersettings"
   Call hNewDocument
   sleep 3
   FilePrintersettings
   Kontext "DruckerEinrichten"
   Call DialogTest (DruckerEinrichten)
   sleep 2
   DruckerEinrichten.Cancel
   sleep 2
   Call hCloseDocument
endcase

testcase tmFileExit
   printlog "- File Close"
   Call hNewDocument
   Sleep 2
   try
      FileExit
      sleep 2
      Kontext
      sleep 2
      Kontext "MessageBox"
      if MessageBox.Exists(1) then ' this is the messagebox from the first window!
         Printlog MessageBox.GetText
         try
            MessageBox.OK
         catch
            MessageBox.No
         endcatch
      end if
      Kontext "MessageBox"
      if MessageBox.Exists(1) then
         Warnlog "MsgBox popped up and there were no changes in the document"
         Printlog MessageBox.GetText
         try
            MessageBox.OK
         catch
            MessageBox.No
         endcatch
      end if
   catch
      printlog "this exit is wanted :-)"
   endcatch
   try
      Sleep 20
      call hStartTheOffice ' from master.inc
   catch
      printlog "catch AGAIN"
   endcatch
   Kontext "SD_Praesentation"
   if SD_Praesentation.exists (2) then
      ViewToolbarsPresentation
   endif
endcase

testcase tdFileExport
   dim x as integer
'/// just call File->Export and exit ///'
   Call hNewDocument
   sleep 3
   FileExport
      Kontext "ExportierenDlg"
      Call DialogTest ( ExportierenDlg )
      UebergeordneterOrdner.Click
      Kontext "SpeichernDlg"
      '/// check number of available export filters. it has to be 17 ///'
      '///+ this is also done in the 'first test', I provide it just as an additional info here.///'
      '///+ testcase: ExFilterCountCompare ///'
      x=Dateityp.getitemcount
      if x <> 18 then warnlog "the number of filters is not 18, it is: " + x
   SpeichernDlg.Cancel
   sleep 2
   Call hCloseDocument
   sleep 2
endcase

