'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: id_011.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:53:20 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* Owner : thorsten.bosbach@sun.com
'*
'* short description :
'*
'***********************************************************************************
' #1 tiTextToolbar
' #1 tiDrawObjectBar
' #1 tiGraphicsObjectBar
' #1 tiGluepointToolbar
' #1 tdBezierToolbar
'\**********************************************************************************

'   hGrafikeinfuegen ConvertPath (gTesttoolPath + "global\input\graf_inp\desp.bmp")

sub id_011
   printLog Chr(13) + "---------    id_011    ----------"

   call tiTextToolbar
   call tiDrawObjectBar
   call tiGraphicsObjectBar
   call tiGluepointToolbar
   call tdBezierToolbar
   '      tDiaToolbar not available in DRAW!
end sub

testcase tiTextToolbar
 Dim Zufall as integer
 Dim i as integer

'/// open application ///'
 Call hNewDocument
  sleep 3
'/// create a textframe with text ///'
  hTextrahmenErstellen ("This is a Text, which will be formatted in several ways", 20,20,40,80)
'/// The 'Object Toolbar' now changes ///'
   sleep 1
'/// select of the text with <STRG> + <A> ///'
   hTypeKeys "<MOD1 A>"
   sleep 1

   Kontext "OL_SD_Text"
   sleep 3
      Printlog "- choose random font"
   randomize
   Zufall=((2*Rnd)+1)      ' wird nicht auf den verfuegbaren bereich getreckt :-( TODO TBO!
   Schriftart.GetItemcount
   Schriftart.GetSelText
   Schriftart.Select Zufall
'/// select any font you like in the listbox 'Font' on 'Object Toolbar' ///'
   Printlog Schriftart.GetSelText + " chosen"

  Kontext "OL_SD_Text"
   sleep 1
      Printlog "- Change size of font"
'/// select any font you like in the listbox 'Size' on 'Object Toolbar' ///'
   Schriftgroesse.Select Zufall
   Printlog Schriftgroesse.GetSelText + " chosen"

 Kontext "OL_SD_Text"
   Printlog "- Font attribute bold"
'/// click button 'Bold' ///'
  Fett.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Font attribute cursive"
'/// click button 'Italic' ///'
  Kursiv.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Font attribute cursiv"
'/// click button 'Underline' ///'
  Unterstrichen.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- font attribute color"
'/// click button 'Font Color' and tearoff the box ///'
    Schriftfarbe.TearOff
    Kontext "TB_Farbe"
    TB_Farbe.Move 20, 20
    Sleep 1
'/// double click in the middle of the box ///'
    TB_Farbe.MouseDoubleClick 50, 50
    Sleep 1
'/// close box 'Font Color' ///'
    TB_Farbe.Close

 Kontext "OL_SD_Text"
   Printlog "- Allign text left"
'/// click button 'Left' ///'
  Linksbuendig.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Allign text centered"
'/// click button 'Centered' ///'
  Zentriert.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- align text to right"
'/// click button 'Right' ///'
  Rechtsbuendig.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Justified"
'/// click button 'Justified' ///'
 Blocksatz.Click
 sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Raising Font spacing"
'/// click button 'Increase Spacing' ///'
  ZeilenabstandErhoehen.Click
  sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Decrease Spacing"
'/// click button 'Decrease Spacing' ///'
  ZeilenabstandVerringern.Click
   sleep 1

 Kontext "OL_SD_Text"
   Printlog "- Numbering and Bullets"
  sleep 1
'/// click button 'Bullets On/Off' ///'
  Aufzaehlung.Click
  sleep 1
'/// click button 'Bullets On/Off' ///'
  Aufzaehlung.Click

   Kontext "OL_SD_Text"
   Printlog "- Text direction from left to right"
   sleep 1
   '/// click button 'Text direction from left to right' ///'
   try
      HorizontalDirection.Click
      printlog "hor does work :-)"
      if (gAsianSup = FALSE) then
         warnlog " this doesn't have to work if asian lang support is disabled :-)"
      endif
   catch
      if (gAsianSup = TRUE) then
         warnlog "hor does NOT work :-("
      endif
   endcatch
   Printlog "'/// click button 'Text direction from top to bottom' ///'"
   try
      VerticalDirection.Click
      printlog "ver does work :-)"
      if (gAsianSup = FALSE) then
         warnlog " this doesnt have to work if asian lang support is disabled :-)"
      endif
   catch
      if (gAsianSup = TRUE) then
         warnlog "ver does NOT work :-( , AsianLanguage support is enabled !"
      endif
   endcatch

  Printlog "- open character dialog"
  Kontext "OL_SD_Text"
   sleep 1
'/// click button 'Character' ///'
   Zeichenformat.Click
    sleep 1
    Kontext
    Active.SetPage TabFont
    Kontext "TabFont"
    sleep 1
    if TabFont.Exists Then
'/// close dialog 'character' ///'
       TabFont.Cancel
       Printlog "- Tabfont exists"
    else
       Warnlog "- No dialog exists "
    end if

  Kontext "OL_SD_Text"
   sleep 2
   Printlog "- call properties for paragraph using text object toolbar"
'/// click button 'Paragraph' ///'
   Absatzformat.Click
   sleep 2
   Kontext
   Active.SetPage TabTabulator
    Kontext "TabTabulator"
     if TabTabulator.Exists Then
        Printlog "- TabTabulator exists"
'/// close dialog 'Paragraph' ///'
        TabTabulator.Cancel
     else
        Warnlog "- TabTabulator does not exist"
     end if

   if (UCase(gApplication)) = "IMPRESS" then  ' IMPRESS only
  '/// if the Application is Impress: ///'

  Kontext "OL_SDD_Text"
      '/// click button 'Numbering Symbols' ///'
      Numerierung.Click
      kontext
      if active.exists (5) then
         messagebox.SetPage TabOptionenNumerierung
         kontext "TabOptionenNumerierung"
         '/// cancel dialog 'Numbering/Bullets' ///'
        if (TabOptionenNumerierung.exists (5) ) then
            Printlog "Numbering/Bullets window came up :-)"
            sleep 1
           TabOptionenNumerierung.cancel
        else
            warnlog "no Numbering/Bullets window came up :-("
        endif
         sleep 1
      else
         warnlog "no Numbering/Bullets window came up :-( 2"
      endif

      Printlog "-change order of outline points"
      sleep 3
    '/// View->Master View->Outline View ///'
      ViewMasterviewOutline
      sleep 3
       Kontext "DocumentImpressOutlineView"
       sleep 1
      '/// type something ///'
       DocumentImpressOutlineView.TypeKeys "Bla bla bla <RETURN><TAB>bla bla bla bla bla <MOD1 SHIFT LEFT>"
       sleep 1
       Kontext "OL_SD_Text"
       sleep 1
      '/// click button 'Denote' ///'
       HierachieHoch
       sleep 1
        Printlog "- Move back down"
      '/// click button 'Promote' ///'
       HierachieRunter
       sleep 1
      Printlog "- Move paragraph up"
      '/// click button 'Move Down' ///'
      AbsatzHoch
      sleep 1
      Printlog "- move paragraph back down and switch to drawing view"
      '/// click button 'Move Up' ///'
      AbsatzRunter
      sleep 1
      Kontext "Vorschau"
       if Vorschau.Exists then
           printlog "- - - - preview window is open, hope there is no problem"
     '     Vorschau.Close
       end if
   else '      DRAW only

       Kontext "OL_SD_Text"
         Printlog "- Double"
      '/// click button 'Double' ///'
        DoubleLineSpacing.Click
         sleep 1

       Kontext "OL_SDd_Text"
         Printlog "- 1.5 lines"
      '/// click button '1.5 lines' ///'
        LinesSpacing15.Click
         sleep 1

       Kontext "OL_SDd_Text"
         Printlog "- Single"
      '/// click button 'Single' ///'
        SingleLineSpacing.Click
         sleep 1
   endif
'/// close application ///'
 Call hCloseDocument
endcase

testcase tiDrawObjectBar
 Dim a as string
 Dim Zaehler as integer
 Dim i,x as integer

'/// open application ///'
 Call hNewDocument
  sleep 3
'/// create rectangle to test the part for draw objects ///'
  Call hRechteckErstellen (20,20,70,70)
   sleep 1
'--------------------------- format line --------------------------------
   Printlog "- call format line using graphic object toolbar"
  Kontext "OL_SD"
  sleep 3
'/// click button 'line' on 'Object Toolbar' ///'
  Linie.Click
   sleep 2
   Kontext
   Active.SetPage TabLinie
   Kontext "TabLinie"
    if TabLinie.Exists Then
'/// cancel dialog 'line' ///'
       TabLinie.Cancel
       Printlog "- TabLinie exists "
    else
       Warnlog "- TabLinie does not exist"
    end if

'--------------------------- Linienendenstil ----------------------------------------
   Printlog "- Style of line ends"
  Kontext "OL_SD"
   sleep 1
'/// click button 'Arrow Style' and tearoff the box ///'
   Linienendenstil.TearOff
   sleep 2
   Kontext "Linienenden"
    if Linienenden.Exists Then
       Printlog "- dialog exists"
'/// close toolbox 'arrowheads' ///'
       Linienenden.Close
    else
       Warnlog "- Arrowheads does not exist"
    end if

'--------------------------- Linienstil ----------------------------------------------
   Printlog "- choose style of lines using graphic object toolbar"

  Kontext "OL_SD"
   sleep 1
'/// select 2nd entry from the top in listbox 'Line Style' ///'
   Linienstil.Select 2
    Printlog Linienstil.GetSelText + " chosen"
'/// select last entry in listbox 'Line Style' ///'
    Linienstil.Select Linienstil.GetItemCount
    Printlog  Linienstil.GetSelText + " chosen"
   sleep 2

'--------------------------- Linienbreite---------------------------------------------
   Printlog "- check style of lines using graphic object toolbar"
  Kontext "OL_SD"
   sleep 1
   a = Linienbreite.GetText
   SetClipboard a
   sleep 1
'/// set 'Line Width' to "0,5" ///'
   Linienbreite.SetText "0,5"
   sleep 2
'/// check if the value is accepted or not ///'
    if Linienbreite.GetText = a Then
       Warnlog "- changes in edit field did not happen; is: '"+Linienbreite.GetText+"', should be : '"+"0,5"+"'"
    else
       Printlog "- Width of lines changed"
    end if

'--------------------------- Linienfarbe ----------------------------------------------
   Printlog "- change line color"
  Kontext "OL_SD"
   sleep 1
   Zaehler = Linienfarbe.GetItemCount
   randomize
   i = Int(Zaehler*Rnd+1)
'/// select some entry in the listbox 'Line Color' ///'
   Linienfarbe.Select i
      Printlog Linienfarbe.GetSelText + " chosen"

'--------------------------- Flaechenformatierung ------------------------------------
   Printlog "- Call Format area using graphic object toolbar"
  Kontext "OL_SD"
   sleep 1
'/// click button 'Area' ///'
   try
      Flaeche.Click
   catch
      printlog "clicking on area took ages :-("
   endcatch
   sleep 10
   Kontext
   Active.SetPage TabArea
   Kontext "TabArea"
    if TabArea.Exists Then
       Printlog "- TabArea exists "
'/// cancel dialog 'Area' ///'
       TabArea.Cancel
    else
       Warnlog "- TabArea does not exist"
    end if

'---
  Kontext "OL_SD"
   sleep 1
   x = AreaStyle.GetItemCount
   for i = 1 to x
      AreaStyle.Select i
      Printlog "Area Style: (" + i + "/" + x + ") - " + AreaStyle.GetSelText
      sleep 1
'/// for every item in the listbox 'Area Style' select the last item in the listbox 'Area Filling' ///'
      Printlog "     Area Filling " + AreaFilling.GetSelIndex + " - " + AreaFilling.GetItemCount
      if (i <> 1) AND (AreaFilling.GetItemCount <> 0) then
         if (AreaFilling.GetSelIndex = 0) AND (AreaFilling.GetItemCount > 0) then
            printlog "default item is 0 => means nothing; NO BUG! 100909"
         endif
         AreaFilling.Select (AreaFilling.GetItemCount)
         Printlog "           Selected: " + AreaFilling.GetSelIndex + " - " + AreaFilling.GetSelText
      endif
   next i

'---------------------------- Schatten -------------------------------------------
   Printlog "- Assign shadow using graphic object toolbar"
  Kontext "OL_SD"
   sleep 1
'/// click button 'Shadow' ///'
   Schatten.Click
   sleep 1
   Printlog "- shadow assigned"

'---------------------------- Praesentationsflyer -----------------------------------
'/// if Application is Impress: ///'
   if (UCase(gApplication)) = "IMPRESS" then  ' IMPRESS only
       Printlog "- Call presentation flyer"
      Kontext "SD_Praesentation" ' first check , if presentation flyer is up! if not -> make it up :-)
'///+ if 'Presentation Box' is not visible, click button 'Presentation Box on/off' ///'
      if SD_Praesentation.Exists Then
         printlog "- flyer is already visible :-)"
      else
         printlog "- flyer wasn't visible :-( - will be now!"
         Kontext "OL_SD"
         sleep 1
         Praesentationsflyer.Click
      endif
      sleep 2
      Kontext "OL_SD"
      sleep 1
'///+ press button 'Presentation Box on/off' to make it disappear///'
      Praesentationsflyer.Click    ' close it
      sleep 2
      Kontext "SD_Praesentation"
      if SD_Praesentation.Exists Then
         Warnlog "- flyer still exist :-("
      else
         Printlog "- Flyer is closed :-)"
'///+ View->Toolbars->Presentation ///'
          ViewToolbarsPresentation  ' put it up again!
      end if
   endif ' IMPRESS only

'/// close application ///'
  Call hCloseDocument
endcase

testcase tiGraphicsObjectBar
 dim i as integer
'/// open application ///'
  Call hNewDocument
   sleep 3
'/// insert a graphic "global\input\graf_inp\desp.bmp" ///'
   hGrafikeinfuegen ConvertPath (gTesttoolPath + "global\input\graf_inp\desp.bmp")
     sleep 1
     Kontext "OL_SDD_Grafik"
     sleep 1
'/// click button 'Filter' and tearoff the box in the Objectbar///'
     Filter.TearOff
     sleep 1
     Kontext "TB_Filters"
     sleep 1
     Printlog "invert"
'/// click button 'Invert' in window 'Filters' ///'
     Invert.Click
     sleep 3
     Printlog "smooth"
'/// click button 'Smooth' in window 'Filters' ///'
     Smooth.Click
     sleep 3
     Printlog "sharpen"
'/// click button 'Sharpen' in window 'Filters' ///'
     Sharpen.Click
     sleep 3
     Printlog "remove noise"
'/// click button 'RemoveNoise' in window 'Filters' ///'
     RemoveNoise.Click
     sleep 3
     Printlog "solarization"
'/// click button 'Solarization' in window 'Filters' ///'
     Solarization.Click
     sleep 3
     Kontext "Solarization"
     if Solarization.exists (5) then
        sleep 1
        Call Dialogtest ( Solarization )
        sleep 1
'///  press 'more' and 'less' in field 'Trashold Value' on dialog 'Solarization' ///'
        Value.More
        Value.Less
'/// check checkbox 'Invert' on dialog 'Solarization' ///'
        Invert.Check
'/// close dialog 'Solarization' with OK ///'
        Solarization.OK
     else
      warnlog "solarization didn't came up :-("
     endif
     sleep 1
     Kontext "TB_Filters"
     sleep 1
     Printlog "aging"
'/// click button 'Aging' in window 'Filters' ///'
     Aging.Click
     Kontext "Aging"
        sleep 1
        Call Dialogtest ( Aging )
  '///  press 'more' and 'less' in field 'Aging degree' on dialog 'Aging' ///'
        AgingDegree.More
        AgingDegree.Less
        sleep 1
  '/// close dialog 'Aging' with OK ///'
        Aging.OK
        sleep 1
     Kontext "TB_Filters"
     sleep 1
     Printlog "poster"
'/// click button 'Posterize' in window 'Filters' ///'
     Posterize.Click
        sleep 1
        Kontext "Posterize"
        sleep 1
        Call Dialogtest ( Posterize )
  '///  press 'more' and 'less' in field 'Aging degree' on dialog 'Posterize' ///'
        PosterColors.More
        PosterColors.Less
        sleep 1
  '/// close dialog 'Posterize' with OK ///'
        Posterize.OK
     sleep 2
     kontext "TB_Filters"
     sleep 1
     Printlog "pop"
'/// click button 'PopArt' in window 'Filters' ///'
     PopArt.Click
     sleep 3
     Printlog "charcoal"
'/// click button 'CharcoalSketch' in window 'Filters' ///'
     CharcoalSketch.Click
     sleep 3
     Printlog "relief"
'/// click button 'Relief' in window 'Filters' ///'
     Relief.Click
        Kontext "Relief"
        sleep 1
        Call Dialogtest ( Relief )
        LightSource.TypeKeys "<left><up>"
  '/// close dialog 'Relief' with OK ///'
     Relief.OK
     sleep 3
     Kontext "TB_Filters"
     Printlog "mos"
'/// click button 'Mosaic' in window 'Filters' ///'
     Mosaic.Click
        sleep 1
        Kontext "Mosaic"
        sleep 1
        Call Dialogtest ( Mosaic )
  '///  press 'more' and 'less' in field 'Width' on dialog 'Mosaic' ///'
        Width.More
        Width.Less
  '///  press 'more' and 'less' in field 'Height' on dialog 'Mosaic' ///'
        Height.More
        Height.Less
  '///  check checkbox 'Enhance Edges' on dialog 'Mosaic' ///'
        EnhanceEdges.Check
  '/// close dialog 'Mosaic' with OK ///'
     Mosaic.OK
     sleep 3
     Kontext "TB_Filters"
  '/// close dialog 'Filters' ///'
     TB_Filters.Close

     Kontext "OL_SDD_Grafik"
     sleep 1
'/// select every entry in the listbox 'Graphics mode' ///'
     for i = 1 to Grafikmodus.GetItemCount
        Grafikmodus.select i
        sleep 1
     next i
  '///  press 'more' and 'less' in field 'Red' on objectbar ///'
   try
     Rotanteil.More
     Rotanteil.Less
   catch
      warnlog "not working from testtool redvalue "+   rotanteil.GetRT
   endcatch
  '///  press 'more' and 'less' in field 'Green' on objectbar ///'
   try
     Gruenanteil.More
     Gruenanteil.Less
   catch
      warnlog "not working from testtool Greenvalue."
   endcatch
  '///  press 'more' and 'less' in field 'Blue' on objectbar ///'
   try
     Blauanteil.More
     Blauanteil.Less
   catch
      warnlog "not working from testtool Bluevalue."
   endcatch
  '///  press 'more' and 'less' in field 'Brightness' on objectbar ///'
   try
     Helligkeit.More
     Helligkeit.Less
   catch
      warnlog "not working from testtool Brightness."
   endcatch
  '///  press 'more' and 'less' in field 'Contrast' on objectbar ///'
   try
     Kontrast.More
     Kontrast.Less
   catch
      warnlog "not working from testtool Contrast."
   endcatch
  '///  press 'more' and 'less' in field 'Gamma' on objectbar ///'
   try
     Gamma.More
     Gamma.Less
   catch
      warnlog "not working from testtool Gamma."
   endcatch
  '///  press 'more' and 'less' in field 'Transparency' on objectbar ///'
   try
     Transparenz.More
     Transparenz.Less
   catch
      warnlog "Not working from testtool Transparency."
   endcatch
'/// press button 'Crop'  on objectbar ///'
     Crop.click
        kontext "TabZuschneiden"
  '///  check radiobutton 'Keep scale' on dialog 'Crop' ///'
        GroesseBeibehalten.Check
  '///  check radiobutton 'Keep Image Size' on dialog 'Crop' ///'
        MassstabBeibehalten.Check
  '///  press 'more' and 'less' in field 'Left' in section 'Crop' on dialog 'Crop' ///'
        Links.More
        Links.Less
  '///  press 'more' and 'less' in field 'Right' in section 'Crop' on dialog 'Crop' ///'
        Rechts.More
        Rechts.Less
  '///  press 'more' and 'less' in field 'Top' in section 'Crop' on dialog 'Crop' ///'
        Oben.More
        Oben.Less
  '///  press 'more' and 'less' in field 'Bottom' in section 'Crop' on dialog 'Crop' ///'
        Unten.More
        Unten.Less
  '///  press 'more' and 'less' in field 'Width' in section 'Scale' on dialog 'Crop' ///'
        MassstabBreite.More
        MassstabBreite.Less
  '///  press 'more' and 'less' in field 'Height' in section 'Scale' on dialog 'Crop' ///'
        MassstabHoehe.More
        MassstabHoehe.Less
  '///  press 'more' and 'less' in field 'Width' in section 'Image size' on dialog 'Crop' ///'
        GroesseBreite.More
        GroesseBreite.Less
  '///  press 'more' and 'less' in field 'Height' in section 'Image size' on dialog 'Crop' ///'
        GroesseHoehe.More
        GroesseHoehe.Less
  '///  click button 'Original Size' on dialog 'Crop' ///'
        Originalgroesse.Click
  '/// cancel dialog 'Crop' ///'
     TabZuschneiden.Cancel

'/// close application ///'
  Call hCloseDocument
endcase


testcase tiGluepointToolbar
'/// open application ///'
  Call hNewDocument
   sleep 3
'/// create 2 rectangles ///'
   Call hRechteckErstellen 20,20,40,40
   sleep 2
   Call hRechteckErstellen 60,60,80,80
   sleep 2
'/// View->Toolbars->Option Bar ///'
   ViewToolbarsOptionbar
'/// at the bottom of the office has a toolbar to appear ///'
   sleep 2

   if (UCase(gApplication)) = "IMPRESS" then
       Kontext "SDD_Optionsleiste"
       if SDD_Optionsleiste.Exists = False Then
           AnsichtOptionsLeiste
           Kontext "SDD_Optionsleiste"
           if SDD_Optionsleiste.Exists = False Then
              warnlog "Can't open options toolbar :-( - REAL problem! :-("
           endif
       end if
    else
       Kontext "SD_Optionsleiste"
       if SD_Optionsleiste.Exists = False Then
           AnsichtOptionsLeiste
           Kontext "SD_Optionsleiste"
           if SD_Optionsleiste.Exists = False Then
              warnlog "Can't open options toolbar :-( - REAL problem! :-("
           endif
       end if
    endif
     sleep 2
   Kontext "WL_SD"
   sleep 1
'/// click button 'Connector' on Functionbar ///'
   Verbinder.Click
'/// make a line with the mouse ///'
   gMouseMove 30,30,70,70
   sleep 3

   if (UCase(gApplication)) = "IMPRESS" then
       Kontext "SDD_Optionsleiste"
    else
       Kontext "SD_Optionsleiste"
    endif
       sleep 3
'/// click button 'Edit Glue Points' on Optionbar ///'
       KlebepunkteBearbeiten.Click
'/// 'Objectbar' has to change ///'
   Kontext "OL_SD_Klebepunkt"
   if OL_SD_Klebepunkt.Exists = False Then warnlog "SHIT! :-("
   sleep 3
'-------------------------------------- Klebepunkt einfuegen ------------------------------------
   try
'/// click button 'Insert Glue Point' on Objecttoolbar ///'
      PunkteEinfuegen.Click
      sleep 2
'/// click 2 times onto the created line ///'
      gMouseClick 25,30
      sleep 1
      gMouseclick 25,30
      Printlog "- insert gluepoint works"
   catch
      Warnlog "- gluepoint could not be insert. Following errors might have their reason here"
   endcatch
   sleep 3
   Kontext "OL_SD_Klebepunkt"

'-------------------------------------- Links ---------------------------------------------------
   try
'/// click button 'Exit Direction Left' on Objecttoolbar ///'
      Links.Click
      Printlog "- gluepoint left works"
   catch
      Warnlog "- gluepoint left does not work"
   endcatch
   sleep 1
'-------------------------------------- Rechts -------------------------------------------------
   try
'/// click button 'Exit Direction Right' on Objecttoolbar ///'
      Rechts.Click
      Printlog "- gluepoint right works"
   catch
      Warnlog "- gluepoint right does not work"
   endcatch
   sleep 1
'-------------------------------------- Oben ----------------------------------------------------
   try
'/// click button 'Exit Direction Top' on Objecttoolbar ///'
      Oben.Click
      Printlog "- gluepoint top works"
   catch
      Warnlog "- gluepoint top does not work"
   endcatch
   sleep 1
'-------------------------------------- Unten ---------------------------------------------------
   try
'/// click button 'Exit Direction Bottom' on Objecttoolbar ///'
      Unten.Click
      Printlog "- gluepoint bottom works"
   catch
      Warnlog "- gluepoint bottom does not work"
   endcatch
   sleep 1
'------------------------------------- Position an Objekt anpassen ------------------------------
   try
'/// click button 'Glue Point Relative' on Objecttoolbar ///'
      PositionAnObjektAnpassen.Click
      Printlog "- align position to object works"
      gMouseClick 25,30      ' if you don't click onto an existing point, the state changes back :-[
   catch
      Warnlog "- align position to object does not work"
   endcatch
   Kontext "OL_SD_Klebepunkt"
   sleep 1
'------------------------------------- Horizontal links -----------------------------------------
   if (OL_SD_Klebepunkt.GetState ( 8, 2 ) =1 ) then PositionAnObjektAnpassen.Click ' make unpressed!
   sleep 2
   try
      Kontext "OL_SD_Klebepunkt"
'/// click button 'Glue Point Horizontal Left' on Objecttoolbar ///'
      HorizontalLinks.Click
      Printlog "- align horizontal left works"
   catch
      Warnlog "- align horizontal left does not work"
      PositionAnObjektAnpassen.Click ' that's the middle button, it has to be UP/not activated!
      for i = 1 to OL_SD_Klebepunkt.GetItemCount
         if (OL_SD_Klebepunkt.GetState ( i, 0 ) <> 0 ) then ' is no seperator
            printlog "----------------------------------------------------------------------"
            printlog "helpid  : " + OL_SD_Klebepunkt.Getstate ( i, 0 ) + "  number in row: " + i
            printlog "itemtype: " + OL_SD_Klebepunkt.GetState ( i, 1 )
            printlog "state   : " + OL_SD_Klebepunkt.GetState ( i, 2 )
            printlog "----------------------------------------------------------------------"
         endif
      next i
   endcatch
   sleep 2
'------------------------------------- Horizontal rechts ----------------------------------------
   try
'/// click button 'Glue Point Horizontal Right' on Objecttoolbar ///'
      HorizontalRechts.Click
      Printlog "- Align horizontal right does work"
   catch
      Warnlog "- Align horizontal right does notwork"
   endcatch
   sleep 1
'------------------------------------- Horizontal zentriert -------------------------------------
   try
'/// click button 'Glue Point Horizontal Center' on Objecttoolbar ///'
      HorizontalZentriert.Click
      Printlog "- align horizontal center does work"
   catch
      Warnlog "- align horizontal center does work"
   endcatch
   sleep 1
'------------------------------------- Vertikal oben --------------------------------------------
   try
'/// click button 'Glue Point Vertical Top' on Objecttoolbar ///'
      VertikalOben.Click
      sleep 1
      Printlog "- Align vertical top does work"
   catch
      Warnlog "- Align vertical top does not work"
   endcatch
'------------------------------------- Vertikal unten -------------------------------------------
   try
'/// click button 'Glue Point Vertical Bottom' on Objecttoolbar ///'
      VertikalUnten.Click
      sleep 1
      printlog "- Align vertical bottom does work"
   catch
      Warnlog "- Align vertical bottom does not work"
   endcatch
'------------------------------------- Vertikal zentriert ---------------------------------------
   try
'/// click button 'Glue Point Vertical Center' on Objecttoolbar ///'
      VertikalZentriert.Click
      sleep 1
      Printlog "- Align vertical center does work"
   catch
      Warnlog "- Align vertical center does not work"
   endcatch

  Printlog "- End of testing gluepoints"
'/// close application ///'
 Call hCloseDocument
endcase

testcase tdBezierToolbar
'/// open application ///'
 Call hNewDocument
  sleep 3
'/// click on the symbol 'Curve' on the toolbar 'Main Toolbar' ///'
  Kontext "WL_SD"
   sleep 1
   Kurven.Click
'/// make some moves & clicks with the mouse ///'
   gMouseDown  20,20
      gMouseMove2 30,30
         gMouseDown  30,30
      gMouseMove2 25,30
      gMouseMove2 35,33
      gMouseMove2 40,40
         gMouseDown  40,40
      gMouseMove2 30,50
      gMouseMove2 50,60
   gMouseUp    60,60
    sleep 1
'/// click on the symbol 'Edit Points' on the toolbar 'Object Toolbar' ///'
  Kontext "OL_SD"
   PunkteBearbeiten.Click
    sleep 2

'----------------------------- Punkte verschieben -------------------------------------
'/// The 'Object Toolbar' now changes ///'
   Kontext "OL_SD_Bezier"
   if OL_SD_Bezier.Exists <> TRUE then
      Kontext "OL_SD"
      PunkteBearbeiten.Click
      Sleep 2
   end if
'/// select a part of the object with spanning a selection with the mouse ///'
   gMouseMove 18,18,33,33

    sleep 1
    Kontext "OL_SD_Bezier"
     sleep 1
   Printlog "- move points"
'/// click button 'Move points' on 'Object Toolbar' ///'
    Verschieben.Click
    sleep 2
      Printlog "- insert points"
'/// click button 'Insert points' on 'Object Toolbar' ///'
    Einfuegen.Click
    sleep 2
      Printlog "- delete points"
'/// click button 'Delete points' on 'Object Toolbar' ///'
    Loeschen.Click
    sleep 2

'/// select an other part of the object with spanning a selection with the mouse ///'
   gMouseMove 25,25,60,60

    sleep 2
    Kontext "OL_SD_Bezier"
    sleep 2
      Printlog "- break curve"
    try
'/// click button 'split curve' on 'Object Toolbar' ///'
       Auftrennen.Click
    catch
      Warnlog "- Auftrennen could not be executed"
    endcatch
    sleep 2

'/// select an other part of the object with spanning a selection with the mouse ///'
   gMouseMove 25,25,45,45

    sleep 2
    Kontext "OL_SD_Bezier"
    sleep 2
      Printlog "- convert into curve"
'/// click button 'convert to curve' on 'Object Toolbar' ///'
    InKurve.Click
    sleep 2
      Printlog "- place edge point"
'/// click button 'corner point' on 'Object Toolbar' ///'
    Ecke.Click
    sleep 2
      Printlog "- smooth transition"
'/// click button 'smooth transition' on 'Object Toolbar' ///'
    Glatt.Click
    sleep 2
      Printlog "- symetric transition"
'/// click button 'symmetric transition' on 'Object Toolbar' ///'
    Symmetrisch.Click
    sleep 2
      Printlog "close bezier"
try
'/// click button 'close bezier' on 'Object Toolbar' ///'
    Schliessen.Click
catch
    InKurve.Click
    sleep 2
   try
       Schliessen.Click
   catch
      warnlog "Couldn't push button :-( can't reproduce it now, mostly seen on linux, if i loop this test, it happens only 1/5 of the time ... :-)"
   endcatch
endcatch
    sleep 2
'/// click button 'eliminate points' on 'Object Toolbar' ///'
    PunkteReduzieren.Click
    sleep 2
'/// close application ///'
 Call hCloseDocument
endcase

