'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: c_001_.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:59 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/************************************************************************
'*
'* owner : peter.junge@Sun.COM
'*
'* short description  :  Resource test section file
'*
'**************************************************************************
'**
' #1 C_001_    ' Initial routine  
' #1 tFileNewFromTemplate
' #1 tFileOpen
' #1 tFileTextImport
' #1 tFileSave
' #1 tFileSaveAll
' #1 tFileSaveAs
' #1 tFileSaveWithPassword
' #1 tFileVersions
' #1 tmFileSendDocumentAsPDF
' #1 tmFileExportAsPDF
' #1 tmExportAsPDF
' #1 tFileProperties
' #1 tFileDocumenttemplate
' #1 tFilePagepreview
' #1 tFilePrint
' #1 tFilePrintersetup
' #1 tFileClose
' #1 tFileExport
' #1 tFileExit
'**
'\************************************************************************


sub C_001_

Printlog Chr(13) + "--------- C_001_ ---------"


    Call tFileNewFromTemplate
    Call tFileOpen
    call tFileTextImport
    Call tFileSave
    Call tFileSaveAll
    Call tFileSaveAs
    Call tFileSaveWithPassword
    call tFileVersions
    Call tmFileSendDocumentAsPDF
    Call tmFileExportAsPDF
    Call tmExportAsPDF
    Call tFileProperties
    Call tFileDocumenttemplate
    Call tFilePagepreview
    Call tFilePrint
    Call tFilePrintersetup
    Call tFileClose
    Call tFileExport
    Call tFileExit

end sub

'
'-----------------------------------------------------------
'
testcase tFileNewFromTemplate
'/// Menu: File -> New -> From Template ///

  call hNewDocument

    FileNewFromTemplate
    Kontext "TemplateAndDocuments"
      Call DialogTest (TemplateAndDocuments)
      TemplateAndDocuments.Cancel

  call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileOpen
'/// Menu: File -> Open ///

  call hNewDocument

    FileOpen
    Kontext "OeffnenDlg"
      UebergeordneterOrdner.Click
      Standard.Click
      NurLesen.check
      Call DialogTest ( OeffnenDlg )
      OeffnenDlg.Cancel
      
  call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileTextImport
'/// Menu: File -> Open - CVS Filter (has a special options dialog) ///

    dim FileFilter as String
    dim k as integer
    dim kMax as integer

    printlog "Test the import dialog for CSV files"
    FileOpen
    Kontext "OeffnenDlg"
      UebergeordneterOrdner.Click
      Standard.Click
        k = 1
	kMax = Dateityp.GetItemCount
        Dateityp.select k
        while right(Dateityp.getSelText, 17) <> "CSV (*.csv;*.txt)"
          printlog "Filetype: " & Dateityp.getSelText
          k = k + 1
	  if k > kMax then
	     warnlog "CSV filter entry not found"
	     OeffnenDlg.Close
	     goto endsub
	  endif
          Dateityp.select k
        wend
        Dateiname.settext convertpath(gtesttoolpath & "calc\update\input\c_001\import.tst")
        Oeffnen.Click
        Kontext "TextImport"
          if TextImport.exists(2) then
             TextImport.ok
          else
             warnlog "CSV Import failed"
          endif
    
    Kontext "DocumentCalc"
    call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileClose
'/// Menu: File -> Close ///


      Call  hNewDocument

        EditCopy
        EditPaste

        FileClose
        Kontext
        Active.Cancel

        FileClose
        Kontext
        Active.Yes
        Kontext "SpeichernDlg"
        SpeichernDlg.Cancel

        FileClose
        Kontext
        Active.No

endcase
'
'-----------------------------------------------------------
'
testcase tFileSave
'/// Menu: File -> Save ///

    Call  hNewDocument

      EditCopy
      EditPaste
      FileSave
      Kontext "SpeichernDlg"
        UebergeordneterOrdner.click
        Standard.Click
        Dateityp.Select FileFormat
        Call DialogTest (SpeichernDlg)
   SpeichernDlg.Cancel

    call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileSaveAll
'/// Menu: File -> Save All ///

     Call  hNewDocument
    
       EditCopy
       EditPaste
      
     Call  hNewDocument
       EditCopy
       EditPaste

       FileSaveAll
       Kontext "SpeichernDlg"
       SpeichernDlg.Cancel

       Kontext "SpeichernDlg"
       SpeichernDlg.Cancel

       try
          Kontext "SpeichernDlg"
          SpeichernDlg.Cancel
          printlog "3 Save dialogs closed"
       catch
          printlog "2 Save dialogs closed"
       endcatch

      Call hCloseDocument
      Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileSaveAs
'/// Menu: File -> Save As ///

    Call  hNewDocument

      FileSaveAs
      Kontext "SpeichernDlg"
        UebergeordneterOrdner.Click
        Standard.Click
        Call DialogTest ( SpeichernDlg )
        SpeichernDlg.Cancel

    call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileSaveWithPassword
'/// Menu: File -> Save - With checked password option in save dialog ///

    Dim Datei$ : Datei$ = convertpath(gOfficePath & "user/work/password.sxc" )
    if Dir(Datei$) <> "" then kill Datei$
    Dim Datei1$ : Datei1$ = convertpath(gOfficePath & "user/work/test.sxc" )
    if Dir(Datei1$) <> "" then kill Datei1$

    Call hNewDocument
      DocumentCalc.TypeKeys "Random stupid content<Return>"
      FileSave
      Kontext "SpeichernDlg"
        printlog "FileFormat: " & FileFormat
        Dateityp.Select FileFormat
        try
           Passwort.Check
           printlog "Password checked"
        catch
           warnlog "If it is not possible to check or uncheck the password it's a bug."
        endcatch
        UebergeordneterOrdner.Click
        Standard.Click
        if NOT passwort.ischecked then
          try
             passwort.check
             warnlog "Password was lost by changign the directory"
          catch
             warnlog "If it is not possible to check or uncheck the password it's a bug."
          endcatch
        end if
        Dateiname.settext Datei$
        if AutomatischeDateinamenserweiterung.ischecked then AutomatischeDateinamenserweiterung.uncheck
        Speichern.Click

        Kontext "Active"
          if Active.Exists(2) then Active.Yes
   '///+ Test wrong verification of password  ///
        Kontext "Passwort"
          printlog "1st test - wrong confirmation"
          PasswortName.settext "Tiberius"
          PasswortBestaetigen.SetText "12345678"
          Call DialogTest ( Passwort )
          Passwort.Ok

        Kontext
          if active.exists then
            active.ok
       '///+ Test correct verification of password ///
            Kontext "Passwort"
              printlog "2nd test - correct confirmation"
              PasswortName.settext "Tiberius"
              PasswortBestaetigen.SetText "Tiberius"
              Passwort.Ok
          else
            warnlog "Wrong confirming wasn't noticed -> BUG"
          end if

        FileClose
      
      FileOpen
      Kontext "OeffnenDlg"
        Dateiname.settext Datei$
        Oeffnen.Click
   '///+ Test reopening the file passwowrd protected file ///
        Kontext "PasswordFileOpen"
          printlog "reopening file"
          PasswortName.settext "Tiberius "
          PasswordFileOpen.Ok

      Kontext
        if active.exists then
          active.ok
     FileOpen
          Kontext "OeffnenDlg"
            Dateiname.settext Datei$
            Oeffnen.Click
            Kontext "PasswordFileOpen"
              PasswortName.settext "Tiberius"
              PasswordFileOpen.Ok
        else
          warnlog "Wrong password wasn't noticed by loading the document"
        end if
   
      FileSaveAs
      Kontext "SpeichernDlg"
        Dateiname.Settext Datei1$
        if AutomatischeDateinamenserweiterung.ischecked then AutomatischeDateinamenserweiterung.uncheck
        if Passwort.isChecked then Passwort.unCheck
        Speichern.Click
        Kontext "Active"
          if Active.Exists(2) then Active.Yes
        call hCloseDocument
    
      FileOpen
      Kontext "OeffnenDlg"
        Dateiname.settext Datei1$
        Oeffnen.Click
        Kontext "PasswordFileOpen"
          printlog "Test if a later deselection of password works."
          if PasswortName.exists then
            warnlog "Despite of saving the document with another name it was required a password:-> Bug!"
            PasswortName.settext "Tiberius"
            call hCloseDocument
          else
            Kontext "Active"
              if Active.Exists then
                WarnLog " MessageBox : " + Active.GetText
                Active.OK
              else
                hCloseDocument
              end if
          end if
     
    if Dir(Datei$) <> "" then kill Datei$
    if Dir(Datei1$) <> "" then kill Datei1$

endcase
'
'-----------------------------------------------------------
'
testcase tFileVersions
'/// Menu: File -> Versions... ///
    call hNewDocument

      call hSpeichernUnterKill convertpath(gOfficePath & "user/work/version.sxc")
      FileVersions
      Kontext "Versionen"
        call Dialogtest (Versionen)
        Speichern.click
        Kontext "VersionskommentarEingeben"
          call DialogTest(VersionskommentarEingeben)
          VersionskommentarEingeben.Cancel
          Kontext "Versionen"
            Versionen.close
    
    Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tmFileExportAsPDF
'/// Menu: File -> Export as PDF...
   dim sPDF as string
   dim sTemp as string

   sPDF = "PDF - Portable Document Format"

   '/// open application ///'
   Call hNewDocument
   hTypeKeys ("a<return>")

   '/// File->Export As PDF... ///'
   FileExportAsPDF
      ' the 'Export as PDF' dialog has to come up, with the only 'File type' 'PDF - Portable Document Format'
      kontext "ExportAsPDFDlg"
        sTemp = Dateityp.GetSelText
        if (sTemp <> sPDF) then
          Warnlog "filter for PDF export is missing :-( '" + sPDF + "'"
        endif
        '/// set Textbox 'File name' to "abc" ///'
        Dateiname.SetText "abc"
        '/// uncheck the checkbox 'Automatic file name extension' ///'
        AutomatischeDateinamenserweiterung.UnCheck
        '--33013: CHECKBOX: Selection   HID_FILESAVE_SELECTION
        '/// check if Checkbox 'Selection' is disabled, it HAS to! ///'
        if Selektion.IsEnabled then
           Warnlog "Selection is enabled :-("
        endif
        '/// use the cursor keys in the filebrowser ///'
        DateiAuswahl.TypeKeys "<home><down>"
        '/// click on the button 'Up one level' ///'
        UebergeordneterOrdner.Click
        '/// click on the button 'Create New Directory' ///'
        try
	   NeuerOrdner.Click
           kontext "NeuerOrdner"
             '/// in the dialog $Foldername set textfield 'New' to 'abc' ///'
             OrdnerName.SetText "abc"
             '/// cancel dialog $Foldername ///'
             NeuerOrdner.cancel
	catch
	   QAErrorLog "#108256# - New folder button is not active"
	endcatch
      kontext "ExportAsPDFDlg"
        '/// click on the button 'Default Directory' ///'
        Standard.Click
        '/// click on the button 'Export...' ///'
        Export.Click

        ' if file exists, there is a message...
        kontext
          if messagebox.exists then
             messagebox.Yes ' to go on ....
          endif
        kontext "PDFOptions"
          '/// check radiobutton 'All' ///'
          RangeAll.Check
          '/// check radiobutton 'Pages' ///'
          RangePages.Check
          '/// set textbox '' to '123' ///'
          RangePagesEdit.SetText "123"
          '/// check radiobutton 'Selection' (not enabled in math!) ///'
          if RangeSelection.IsEnabled then
             'Warnlog "RangeSelection is enabled in math ???"
             RangeSelection.Check
          else
             Warnlog "RangeSelection is not enabled :-("
          endif

          '/// check radiobutton 'Screen optimized (smalest filesize)' ///'
          ScreenOptimized.Check
          '/// check radiobutton 'Print optimized' ///'
          PrintOptimized.Check
          '/// check radiobutton 'Press optimized' ///'
          PressOptimized.Check

          '/// cancel dialog 'PDF Options' ///'
          PDFOptions.Cancel

   '/// close application ///'
   Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tmFileSendDocumentAsPDF
'/// Menu: File -> Send -> Document as PDF attachement

   '/// open application ///'
   Call hNewDocument
   hTypeKeys ("a<return>")

   '/// File->Send->Document As PDF Attachment... ///'
   FileSendDocumentAsPDF
   '/// on the dialog 'PDF Options' ///
   kontext "PDFOptions"
      '///+ - check radiobutton 'All' ///'
      RangeAll.Check
      '///+ - check radiobutton 'Pages' ///'
      RangePages.Check
      '///+ - - set textbox '' to '123' ///'
      RangePagesEdit.SetText "123"
      '///+ - check radiobutton 'Selection' (not enabled in math!) ///'
      if RangeSelection.IsEnabled then
         'Warnlog "RangeSelection is enabled in math ???"
         RangeSelection.Check
      else
         Warnlog "RangeSelection is nor enabled :-("
      endif

      '///+ - check radiobutton 'Screen optimized (smalest filesize)' ///'
      ScreenOptimized.Check
      '///+ - check radiobutton 'Print optimized' ///'
      PrintOptimized.Check
      '///+ - check radiobutton 'Press optimized' ///'
      PressOptimized.Check

      '///+ - cancel dialog 'PDF Options' ///'
      PDFOptions.Cancel

   '/// close application ///'
   Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tmExportAsPDF
'/// Function bar -> Export as PDF...

   dim sPDF as string
   dim sTemp as string

   sPDF = "PDF - Portable Document Format"

   '/// open application ///'
   Call hNewDocument
   hTypeKeys ("a<return>")

   '/// click the button 'Export Directly as PDF' on the Functionbar ///'
   kontext "Funktionsleiste"
     ExportAsPDF.click
     ' the 'Export as PDF' dialog has to come up, with the only 'File type' 'PDF - Portable Document Format'
     kontext "ExportAsPDFDlg"
       sTemp = Dateityp.GetSelText
       if (sTemp <> sPDF) then
          Warnlog "filter for PDF export is missing :-( should: '" + sPDF + "'; is: '" +  + "'"
       endif
       '///+ - set Textbox 'File name' to "abc" ///'
       Dateiname.SetText "abc"
       '///+ - uncheck the checkbox 'Automatic file name extension' ///'
       AutomatischeDateinamenserweiterung.UnCheck
       '--33013: CHECKBOX: Selection   HID_FILESAVE_SELECTION
       '/// check if Checkbox 'Selection' is disabled, it HAS to! ///'
       if Selektion.IsEnabled then
          Warnlog "Selection is enabled :-("
       endif
       '///+ - use the cursor keys in the filebrowser ///'
       DateiAuswahl.TypeKeys "<home><down>"
       '///+ - click on the button 'Up one level' ///'
       UebergeordneterOrdner.Click
       '///+ - click on the button 'Create New Directory' ///'
       try
	  NeuerOrdner.Click
          kontext "NeuerOrdner"
            '///+ - - in the dialog $Foldername set textfield 'New' to 'abc' ///'
            OrdnerName.SetText "abc"
            '///+ - - cancel dialog $Foldername ///'
            NeuerOrdner.cancel
       catch
	  QAErrorLog "#108256# - New folder button is not active"
       endcatch
     kontext "ExportAsPDFDlg"
       '///+ - click on the button 'Default Directory' ///'
       Standard.Click
       '///+ - click on the button 'Export...' ///'
       Export.Click

       ' if file exists, there is a message...
       kontext
         if messagebox.exists then
            messagebox.Yes ' to go on ....
         endif

   '/// close application ///'
   Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tFileProperties
'/// Menu: File -> Properties
    Call hNewDocument

    FileProperties
    Kontext
      active.SetPage TabDokumentinfo
      Kontext "TabDokumentinfo"
        Call DialogTest ( TabDokumentinfo )

    Kontext
      active.SetPage TabDokument
      Kontext "TabDokument"
        Call DialogTest ( TabDokument )

    Kontext
      active.SetPage TabBenutzer
      Kontext "TabBenutzer"
        Call DialogTest ( TabBenutzer )
        Infofelder.Click
        Kontext "InfonamenBearbeiten"
          Call DialogTest ( InfonamenBearbeiten )
          InfonamenBearbeiten.Close

    Kontext
      active.SetPage TabStatistikCalc
      Kontext "TabStatistikCalc"
        Call DialogTest ( TabStatistikCalc )

    Kontext
      active.SetPage TabInternet
      Kontext "TabInternet"
        Call DialogTest ( TabInternet )
        TabInternet.Cancel

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFileDocumenttemplate
'/// Menu: File -> Templates -> Organize...
    Call  hNewDocument

    FileTemplatesOrganize
    Kontext "DVVerwalten"
      Call DialogTest (DVVerwalten)
      ListeRechts.Typekeys("<UP>")
      WelcheDatei.Click
      Kontext "OeffnenDLG"
        Call Dialogtest (OeffnenDlg)
        OeffnenDLG.Cancel
      Kontext "DVVerwalten"
        DVVerwalten.Close

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFilePagepreview
'/// Menu: File -> Page Preview
    Call hNewDocument

    Call hTypeKeys ( "13<Return>" )
    FilePageView
    Kontext "OL_SC_Seitenansicht"
      Seitenansicht.Click

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tFilePrint
'/// Menu: File -> Print ...
    Call  hNewDocument
    FilePrint
    'if there is no printer in the system you will get an error
    Kontext
      if Active.Exists(2) then
         if Active.GetRT = 304 then
            printlog Active.GetText
            Active.OK
         end if
      else
         Kontext "DruckenDLG"
         call DialogTest ( DruckenDLG )
         AusdruckInDatei.check
         try
            Kontext "SpeichernDLG"
            SpeichernDLG.Cancel
         catch
            'warnlog "It seems that this dialog isn't available"
	    QAErrorLog "#107672# - Save as dialog doesn't come up"
         endcatch
         Kontext "DruckenDLG"
         'Open the printoptions
         Zusaetze.Click
         Kontext "TabPrintCalcOptions"
           TabPrintCalcOptions.Cancel
         Kontext "DruckenDlg"
         DruckenDlg.Cancel
      
         Kontext "DocumentCalc"
      end if
      
    Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tFilePrintersetup
'/// Menu: File -> Printer settings ...
    Call  hNewDocument
    
    FilePrintersettings
    'if there is no printer in the system you will get an error
    Kontext
      if Active.Exists(2) then
         if Active.GetRT = 304 then
            printlog Active.GetText
            Active.OK
         end if
      else
         Kontext "DruckerEinrichten"
         Call DialogTest ( DruckerEinrichten )
         DruckerEinrichten.Cancel
      end if
      
    Call hCloseDocument
endcase
'
'-----------------------------------------------------------
'
testcase tFileExit
'/// Menu: File -> exit
    call hNewDocument

    Kontext "DocumentCalc"
      DocumentCalc.typekeys ("Bye<RETURN>")
      FileExit
      try
         Kontext "Active"
           if active.exists then
              printlog active.GetText
              active.no
              Kontext "Active"
                if active.exists then
                   printlog active.GetText
                   active.no
                end if
           else
              Warnlog "The modified docment wasn't closed without warning (BugID:90730)"
              FileClose
              Kontext "Active"
              if active.exists then active.no
           end if
      catch
      endcatch

    Kontext "DocumentCalc"
    call hStartTheOffice

endcase
'
'-----------------------------------------------------------
'
testcase tFileExport
'/// Export to Excel 2000
'///+ A complex xml calc document is loaded and exported

   call hDateiOeffnen convertpath(gTesttoolPath & "calc/update/input/c_001/all_features.sxc")
   FileSaveAs
   Kontext "SpeichernDlg"
     Dateiname.setText convertpath(gOfficePath & "user/work/all_features")
     Dateityp.select 5
     AutomatischeDateinamenserweiterung.check
     printlog "Filetype: " & Dateityp.getSelText
     Speichern.click
     Kontext "Active"
       if Active.exists(2) then Active.YES
     sleep 20 ' necessary because it takes some time to save!
     FileClose
     Kontext "Active"
       if Active.exists(2) then
          active.yes
       else
          warnlog "Messagebox for saving in external formats is missing"
       endif
       
'///+ After export to MS Excel, it is tested if this document can be loaded again
   call hDateiOeffnen convertpath(gOfficePath & "user/work/all_features.xls")
   FileClose
   Kontext "Active"
     if active.exists(2) then active.no
     
endcase
