'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: c_002_.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:59 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/*************************************************************************************************
'*
'* owner : peter.junge@sun.com
'*
'* short description : Check all resources for menuitem Edit
'*
'**************************************************************************
'**
' #1 C_002_ ' Initial routine
' #1 tEditUndo
' #1 tEditRedo
' #1 tEditLastCommand
' #1 tEditCut
' #1 tEditCopy
' #1 tEditPaste
' #1 tEditPasteSpecial
' #1 tEditPasteOverwrite
' #1 tEditSelectAll
' #1 tEditRecordModify
' #1 tEditShowModify
' #1 tEditModifyAcceptOrDismiss
' #1 tEditModifyComment
' #1 tEditModifySummarizeDocument
' #1 tEditCompareDocument
' #1 tEditSearchAndReplace
' #1 tEditNavigator
' #1 tEditHeaderAndFooter
' #1 tEditFillOutDown
' #1 tEditFillOutRight
' #1 tEditFillOutTop
' #1 tEditFillOutLeft
' #1 tEditFillOutTable
' #1 tEditFillOutLine
' #1 tEditDeleteContents
' #1 tEditDeleteCells
' #1 tEditDeleteTable
' #1 tEditMoveCopyTable
' #1 tEditDeleteManuelRowBreak
' #1 tEditDeleteManuelColumnBreak
' #1 tEditLink
' #1 tEditPlugin
'**
'\************************************************************************************************

Sub C_002_

Printlog Chr(13) + "--------- C_002_ ---------"

   Call tEditUndo
   Call tEditRedo
   Call tEditLastCommand
   Call tEditCut
   Call tEditCopy
   Call tEditPaste
   Call tEditPasteSpecial
   call tEditPasteOverwrite
   Call tEditSelectAll
   Call tEditRecordModify
   Call tEditShowModify
   Call tEditModifyAcceptOrDismiss
   Call tEditModifyComment
   Call tEditModifySummarizeDocument
   Call tEditCompareDocument
   Call tEditSearchAndReplace
   Call tEditNavigator
   Call tEditHeaderAndFooter
   Call tEditFillOutDown
   Call tEditFillOutRight
   Call tEditFillOutTop
   Call tEditFillOutLeft
   Call tEditFillOutTable
   Call tEditFillOutLine
   Call tEditDeleteContents
   Call tEditDeleteCells
   Call tEditDeleteTable
   Call tEditMoveCopyTable
   Call tEditDeleteManuelRowBreak
   Call tEditDeleteManuelColumnBreak
   Call tEditLink
   Call tEditPlugin


end sub

'TODO: Hier geht's weiter

' -------------------------------------------------------------------------------
' ----------------                                            -------------------
' ----------------              Edit - Menu - Calc            -------------------
' ----------------                                            -------------------
' -------------------------------------------------------------------------------

testcase tEditUndo

    Call  hNewDocument

    call ZellenMarkieren(2,2)
    EditCut
    EditUndo

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditRedo

    Call  hNewDocument

    call ZellenMarkieren(2,2)
    EditCut
    EditUndo
    EditRedo

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditLastCommand

    Call  hNewDocument

    call ZellenMarkieren(2,2)
    EditCut
    EditUndo
    EditRepeat

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditCut

    Call  hNewDocument

    call ZellenMarkieren(2,2)
    EditCut
    EditPaste

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditCopy

    Call  hNewDocument

    EditCopy
    EditPaste

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditPasteSpecial

    dim Datname as String
    dim paste_flag : paste_flag = true

    Call  hNewDocument

    Kontext
    DocumentCalc.typekeys "13<Return><Up>"
    EditCopy
    EditPasteSpecialCalc
    Kontext "InhalteEinfuegenCalc"
    DialogTest ( InhalteEinfuegenCalc )
    InhalteEinfuegenCalc.Cancel
    wait 2000
    try
        InsertGraphicsFromFile
        Kontext "GrafikEinfuegenDlg"
        DatName = convertpath( gTesttoolpath + "global\input\graf_inp\baer.tif" )
        Dateiname.Settext DatName
        'warnlog "If the test crashes by inserting a graphic from file it could be the bug:90336"
        Oeffnen.Click
    catch
    	Warnlog "InsertGraphicFromFile doesn't work!"
    	paste_flag = false
    endcatch
    wait 10000
    if paste_flag = true then
        EditCut
        wait 3000
        EditPasteSpecialCalc
        Kontext "InhaltEinfuegen"
        DialogTest ( InhaltEinfuegen )
        InhaltEinfuegen.Cancel
        Wait 2000
    end if

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditPasteOverwrite

   call hNewDocument
   
   Kontext "DocumentCalc"
     DocumentCalc.typekeys "1<Return>2<Return><Up><MOD1 C><Up><MOD1 V>"
     try
        Kontext "CellWarning"
   	  Dialogtest ( CellWarning )
          CellWarning.No
	printlog "Paste overwrite MsgBox tested"
     catch
       warnlog "MsgBox for overwrite warning doesn't exist"
     endcatch
	 
   call hCloseDocument
   
endcase
'
'-----------------------------------------------------------
'
testcase tEditPaste

    Call  hNewDocument

    DocumentCalc.typekeys "11<Right>12<Right>13<RETURN>23<LEFT>22<LEFT>21<RETURN>31<RIGHT>32<RIGHT>33<UP UP LEFT LEFT>"
    call ZellenMarkieren(3,3)
    EditCopy
    EditPaste
    Kontext "Active"
    if Active.exists then Active.YES
    Call cgotoCell("d4")
    EditPaste
    Kontext
    if active.exists then
    	Warnlog "It shouldn't appear a message: " & active.gettext
    	active.yes
    else
    	Printlog "OK, there isn't appear a message by inserting a range in a market cell"
    end if
    call ZellenMarkieren(2,2)
    EditPaste
    Kontext
    if active.exists then
    	Printlog "OK a mesage has appear" & active.gettext
    	active.yes
    else
    	Warnlog "It should be appear a message by inserting a range in a smaller selection"
    end if
    Kontext "Active"
    if Active.exists then Active.YES

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditSelectAll

    Call  hNewDocument

    EditSelectAll

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditRecordModify

    Call  hNewDocument

    Kontext
    DocumentCalc.typekeys "13<Return>"
    EditChangesRecordCalc
    Kontext
    if active.exists then
    	active.Yes
    	EditChangesRecordCalc
    end if
    Kontext
    DocumentCalc.typekeys "13<Return>"
    EditChangesRecordCalc
    Kontext
    if active.exists then active.No
    Kontext
    DocumentCalc.typekeys "13<Return>"
    EditChangesRecordCalc
    Kontext
    if active.exists then
    	active.Yes
    	Printlog "OK ON, OFF (NO), OFF (YES)"
    end if

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditProtectModify
'/// This testcase check the change protection of calc documents ///
	Call hNewDocument

	'/// At first enter some contents in the document ///
	Kontext
	DocumentCalc.TypeKeys "10<RETURN>10<RETURN>"
	'/// Now switch the RecordModus on ///
	EditChangesRecordCalc
	'/// Then switch the trace protect on
	EditChangesRecordProtectTrace
	Kontext "PasswortEingeben"
	'/// then put in a password ///
	PasswortEingabe.settext "ffff"
	'/// and confirm with a wrong password ///
	PasswortBestaetigen.settext "fffff"
	'/// Now a message should be appear, that the password is wrong ///
	if Active.exits then
		printlog Active.gettext
		printlog "OK, the wrong password was detected"
		active.OK
	else
		warnlog "The wrong password wasn't detected"
	end if
    PasswortBestaetigen.settext "ffff"
    Kontext "DocumentCalc"
    '/// call protect trace again to switch off the protection ///
    EditChangesRecordProtectTrace
    Kontext "PasswortEingeben"
    '/// Put in a wrong password ///
    SchutzAufheben.settext "fffff"
    PasswortEingeben.OK
    '/// and check, if this wrong password is detected ///
    if active.exitst then
    	printlog active.gettext
    	printlog "OK, the wrong password was detected"
    	active.OK
    	EditChangesRecordProtectTrace
    	Kontext "PasswortEingeben"
    	'/// Put in the correct password and close the dialog ///
    	SchutzAufheben.settext "ffff"
    	PasswortEingeben.OK
    else
    	warnlog "The wrong password wasn't detected"
    end if

    call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditShowModify

    Call  hNewDocument

    Kontext
    DocumentCalc.typekeys "13<Return>"
    try
    	EditChangesShowCalc
    catch
    	EditChangesRecordCalc
    	Kontext
    	DocumentCalc.typekeys "13<Return>"
    	EditChangesShowCalc
    endcatch

    Kontext "AenderungenAnzeigen"
    call Dialogtest (AenderungenAnzeigen)
    AenderungenAnzeigen.Cancel

    EditChangesRecordCalc
    Kontext
    if active.exists then active.Yes

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditModifyAcceptOrDismiss

    Call  hNewDocument

    Kontext
    DocumentCalc.typekeys "13<Return>"
    EditChangesRecordCalc
    Kontext
    DocumentCalc.typekeys "13<Return><Up>"
    EditChangesShowCalc

    Kontext "AenderungenAnzeigen"
    AenderungenAnzeigen.Cancel

    EditChangesAcceptOrDiscardCalc
    Kontext "TabAenderungenAnzeigen"
    Kontext "AenderungenAnzeigen"
    Kontext "TabControl"
    TabControl.setpage TabListe
    Kontext "TabListe"
    Call Dialogtest (TabListe)

    Kontext "TabControl"
    TabControl.setpage TabFilter
    Sleep 1
    Kontext "AenderungenAnzeigen"
    AenderungenAnzeigen.close

    EditChangesRecordCalc
    Kontext
    if active.exists then active.Yes

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditModifyComment

    Call  hNewDocument

    Kontext
    DocumentCalc.typekeys "13<Return>"
    try
    EditChangesShowCalc
    catch
    EditChangesRecordCalc
    Kontext
    DocumentCalc.typekeys "13<Return><Up>"
    EditChangesShowCalc
    endcatch
    Kontext "AenderungenAnzeigen"
    AenderungenAnzeigen.Cancel

    EditChangesCommentsCalc
    Kontext "Kommentar"
    if Kommentar.exists then
    call Dialogtest( Kommentar )
    else
    Warnlog "There is no comment"
    end if
    Kommentar.cancel

    EditChangesRecordCalc
    kontext
    if active.exists then active.Yes

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditModifySummarizeDocument

    call hNewDocument

    EditChangesMergeDocument
    Kontext "OeffnenDlg"
    UebergeordneterOrdner.Click
    Standard.Click
    Call DialogTest (OeffnenDlg)
    OeffnenDlg.Cancel

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditCompareDocument

  	Call hNewDocument
  	EditCompareDocumentCalc
  	Kontext "OeffnenDlg"
    UebergeordneterOrdner.Click
    Standard.Click
    Call DialogTest (OeffnenDlg)
    Dateiname.settext convertpath(gtesttoolpath +"calc\update\input\c_010\zusuchen.sxc")
    Oeffnen.Click

	try
  		Kontext "TextImport"
   		if TextImport.exists then TextImport.Ok
  		Kontext "AenderungenAnzeigen"
  		Kontext "TabControl"
  		TabControl.setpage TabListe
  		Kontext "TabListe"
  		Call Dialogtest (TabListe)

  		Kontext "TabControl"
  		TabControl.setpage TabFilter
  		Kontext "TabFilter"
  		Kontext "AenderungenAnzeigen"
  		AenderungenAnzeigen.close
  	catch
  		warnlog "If this test doesn't work, it could be the bug:85779"
  	endcatch

  	call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditSearchAndReplace

    Call  hNewDocument

    'dim i as integer
    'for i = 1 to 10
    EditSearchAndReplace
    Kontext "SuchenUndErsetzenCalc"

    Aehnlichkeitssuche.Check
    AltPunkt.Click
    Kontext "Aehnlichkeitssuche"
    Call DialogTest ( Aehnlichkeitssuche )
    Aehnlichkeitssuche.Cancel
    Kontext "SuchenUndErsetzenCalc"
    Zusaetze.Click
    Call DialogTest ( SuchenUndErsetzenCalc )
    SuchenUndErsetzenCalc.Close
    'next i
    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditNavigator

    Call  hNewDocument

    sleep 1
    EditNavigator
    sleep 1
    Kontext "NavigatorCalc"
    DialogTest ( NavigatorCalc )
    Kontext "Navigator"
    Navigator.Close
    Kontext "NavigatorCalc"
    if NavigatorCalc.exists then
    	EditNavigator
    	Warnlog "NavigatorCalc.Close doesn't close the navigator"
    end if

  	Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditHeaderAndFooter

    Call  hNewDocument

    FormatPageCalc
    Kontext
    Active.SetPage TabKopfzeile
    Kontext
      if Active.Exists(2) then
        if Active.GetRT = 304 then
          Printlog Active.GetText
          Active.Yes
          sleep(2)
        end if
      end if
    Kontext "TabKopfzeile"
    InhaltLinksRechtsGleich.uncheck
    Kontext
    Active.SetPage TabFusszeile
    Kontext "TabFussZeile"
    InhaltLinksRechtsGleich.uncheck
    TabFusszeile.Ok

    EditHeadersAndFooters

    Kontext
    Active.SetPage TabKopfzeileCalc
    Kontext "TabKopfzeileCalc"
    Call DialogTest ( TabKopfzeileCalc )

    Kontext
    Active.SetPage TabKopfzeileCalcLinks
    Kontext "TabKopfzeileCalcLinks"
    Call DialogTest ( TabKopfzeileCalcLinks )

    Kontext
    Active.SetPage TabFusszeileCalc
    Kontext "TabFusszeileCalc"
    Call DialogTest ( TabFusszeileCalc )

    Kontext
    Active.SetPage TabFusszeileCalcLinks
    Kontext "TabFusszeileCalcLinks"
    Call DialogTest ( TabFusszeileCalcLinks )

    Textattribute.Click

    Kontext
    Active.setpage TabFont
    Kontext "TabFont"
    Call DialogTest (TabFont)
    Kontext
    Active.setpage TabFontEffects
    Kontext "TabFontEffects"
    Call DialogTest (TabFontEffects)
    Kontext
    Active.setpage TabFontPosition
    Kontext "TabFontPosition"
    Call DialogTest (TabFontPosition)
    TabFontPosition.Cancel

    Kontext "TabFusszeileCalcLinks"
    TabFusszeileCalcLinks.Close

    FormatPageCalc
    Kontext
    Active.SetPage TabKopfzeile
    Kontext
      if Active.Exists(2) then
        if Active.GetRT = 304 then
          Printlog Active.GetText
          Active.Yes
          sleep(2)
        end if
      end if
    
    Kontext "TabKopfzeile"
    InhaltLinksRechtsGleich.check
    Kontext
    Active.SetPage TabFusszeile
    Kontext "TabFussZeile"
    InhaltLinksRechtsGleich.check
    TabFusszeile.Ok

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tBearbeitenAdressbuch

    Call  hNewDocument

    EditAddressbook
    Kontext "Adressbuch"
    Umschaltbar.Typekeys "<MOD1 1>"
    printlog "Adressbuch / Persoenlich"
    DialogTest2 ( Adressbuch,1 )
    Umschaltbar.Typekeys "<MOD1 2>"
    printlog "Adressbuch / geschaeftlich"
    DialogTest2 ( Adressbuch,2 )
    Umschaltbar.Typekeys "<MOD1 3>"
    printlog "Adressbuch / Sonstiges"
    DialogTest2 ( Adressbuch,3 )
    Adressbuch.close

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditFillOutDown

    Call  hNewDocument

    Call DocumentCalc.Typekeys "13<Return><Up>"
    Call ZellenMarkieren ( 4, 1 )
    EditFillDown

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditFillOutRight

    Call  hNewDocument

    Call DocumentCalc.Typekeys "13<Return><Up>"
    Call ZellenMarkieren ( 1, 4 )
    EditFillRight

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditFillOutTop

    Call  hNewDocument

    Call DocumentCalc.Typekeys "<Down><Down><Down>13<Return><Up><Up><Up><Up>"
    Call ZellenMarkieren ( 4, 1 )
    EditFillUp

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditFillOutLeft

    Call  hNewDocument

    Call DocumentCalc.Typekeys "<Right><Right><Right>13<Return><Up><Left><Left><Left><Left>"
    Call ZellenMarkieren ( 1, 4 )
    EditFillLeft

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditFillOutTable

    Call  hNewDocument

    EditCopyMoveSheet
    Kontext "TabelleVerschiebenKopieren"
    EinfuegenVor.select 2
    Kopieren.Check
    TabelleVerschiebenKopieren.OK
    Kontext
    DocumentCalc.Typekeys "1<Return>=Tabelle1.A1<Return><Up><Up><Shift Down Up>"
    AlleTabellenAuswaehlen

    EditFillSheet
    Kontext "TabellenFuellen"
    DialogTest ( TabellenFuellen )
    TabellenFuellen.Cancel

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditFillOutLine

    Call  hNewDocument

    Call ZellenMarkieren ( 4, 1 )
    EditFillSeries
    Kontext "ReiheFuellen"
    DialogTest ( ReiheFuellen )
    ReiheFuellen.Cancel

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditDeleteContents

    Call  hNewDocument

    EditDeleteContents
    Kontext "InhalteLoeschen"
    DialogTest ( InhalteLoeschen )
    InhalteLoeschen.Cancel

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditDeleteCells

    Call  hNewDocument

    EditDeleteCells
    Kontext "ZellenLoeschen"
    DialogTest ( ZellenLoeschen )
    ZellenLoeschen.Cancel

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditDeleteTable

    Call  hNewDocument

    InsertSheetCalc
    Kontext "TabelleEinfuegenCalc"
    TabelleEinfuegenCalc.Ok
    wait 2000
    EditDeleteSheet
    Kontext
    Active.Yes

    Call hCloseDocument

endcase
'
'-------------------------------------------------------------------------------
'
testcase tEditMoveCopyTable

    Call  hNewDocument

    EditCopyMoveSheet
    Kontext "TabelleVerschiebenKopieren"
    DialogTest ( TabelleVerschiebenKopieren )
    TabelleVerschiebenKopieren.Cancel

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditDeleteManuelRowBreak

    Call  hNewDocument

    DocumentCalc.Typekeys "<Down><Down><Down>"
    InsertManuelBreakRowBreak
    EditRemoveManualBreakRowBreak

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditDeleteManuelColumnBreak

    Call  hNewDocument

    DocumentCalc.Typekeys "<Right><Right>"
    InsertManuelBreakColumnBreak
    wait 50
    EditRemoveManualBreakColumnBreak

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditLink

	dim filename as String

    Call  hNewDocument

    InsertGraphicsFromFile
    Kontext "GrafikEinfuegenDlg"
    filename = ConvertPath ( gTesttoolPath + "global\input\graf_inp\baer.tif" )
    Dateiname.Settext filename
    Link.Check
    'warnlog "If the test crashes by inserting a graphic from file it could be the bug:90336"
    Oeffnen.Click
    Kontext "DocumentCalc"
    EditLinksCalc
    Kontext "VerknuepfungenBearbeiten"
    Call DialogTest ( VerknuepfungenBearbeiten )
    VerknuepfungenBearbeiten.Close

    Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tEditPlugin

      Call  hNewDocument

        EditPlugIn        'Plugin switch on
        EditPlugIn        'Plugin switch off

      Call hCloseDocument

endcase
'
'-----------------------------------------------------------
'
testcase tBearbeitenObjektBearbeiten

   	dim filename as String

    Call  hNewDocument

    InsertGraphicsFromFile
    Kontext "GrafikEinfuegenDlg"
    filename = ConvertPath ( gTesttoolpath + "input\global\baer.tif" )
    Dateiname.SetText filename
    Oeffnen.Click
    Sleep 2
    EditObjectEdit
    Kontext "DocumentCalc"
    DocumentCalc.TypeKeys "<Escape>"

    Call hCloseDocument

endcase

