'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: first.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:52 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : Includefile for the first testscript
'*
'************************************************************************
'*
' #1 tAllNew           ' Open all document types and check the default filtername ( File / Save As )
' #1 tJava             ' Open a HTML-page with an Java applet => testtool only can check if it does not crash
' #1 DocumentCheck     ' Checks name of the file type in the Save dialog and verifys it with a given string.
'*
'\***********************************************************************

testcase tAllNew
  Dim lsList ( 20 ) as String
'///tAllNew : open all applications and check the filternames

   if gUseSysDlg = TRUE then Warnlog "Only check, if the documents will be opened; no check for the defaultfilter ( system file-dialog )!"

'///+<ul><li>Open a Writer document, type text, check the default filtername and close the document</li>
 printlog ""
   try
      gApplication = "Writer"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
      Kontext "DocumentWriter"
      DocumentWriter.TypeKeys "This is a Writer-document!"
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gWriterFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a writerdoc will be opened!"
      end if
      hCloseDocument ( TRUE )
   catch
      Exceptlog
      ResetApplication
   endcatch

'///+<li>Open a Calc document, type text, check the default filtername and close the document</li>
   try
      gApplication = "Calc"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
      Kontext "DocumentCalc"
      DocumentCalc.TypeKeys "This is a Calc-document!"
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gCalcFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a calcdoc will be opened!"
      end if
      hCloseDocument ( TRUE )
    catch
      Exceptlog
      ResetApplication
   endcatch

'///+<li>Open an Impress document, insert a new slide (insert/duplicate slide), check the default filtername and close the document.</li>
   try
      gApplication = "Impress"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
       sleep 3
      InsertDuplicateSlide
      sleep 2
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gImpressFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a impressdoc will be opened!"
      end if
      hCloseDocument ( TRUE )
   catch
      Exceptlog
      ResetApplication
   endcatch

'///+<li>Open a Draw document, insert a new slide (insert/slide), check the default filtername and close the document</li>
   try
      gApplication = "Draw"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
      InsertSlide
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gDrawFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a drawdoc will be opened!"
      end if
      hCloseDocument ( TRUE )
   catch
      Exceptlog
      ResetApplication
   endcatch

'///+<li>Open a HTML document, type text, check the default filtername and close the document</li>
   try
      gApplication = "HTML"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
      Kontext "DocumentWriter"
      DocumentWriter.TypeKeys "Thos is a Html-Document!"
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gHTMLFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a HTMLdoc will be opened!"
      end if
      hCloseDocument ( TRUE )
   catch
      Exceptlog
      ResetApplication
   endcatch

'///+<li>Open a Math document, type a short formula, check the default filtername and close the document</li>
   try
      gApplication = "Math"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
      SchreibenInMathDok "a over b"
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gMathFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a mathdoc will be opened!"
      end if
      hCloseDocument ( TRUE )
   catch
      Exceptlog
      ResetApplication
   endcatch

'///+<li>Open a Master document, type text, check the default filtername and close the document</li></ul>
   try
      gApplication = "GlobalDokument"
      printlog "  - " +  gApplication
      Call hNewDocument ( TRUE )
      Kontext "DocumentWriter"
      DocumentWriter.TypeKeys "This is a master document!"
      if gUseSysDlg = FALSE then
         if DocumentCheck ( gMasterDocFilter ) = FALSE then Warnlog "The filtername ( saving ) is not correct, please check, if a MasterDoc will be opened!"
      end if
      Kontext "Navigator"
      if Navigator.Exists(5) then Navigator.Close
      hCloseDocument ( TRUE )
   catch
      Exceptlog
      ResetApplication
   endcatch

endcase

'-------------------------------------------------------------------------

testcase tJava
  Dim i as Integer

'///tJava: Check a HTML-page with Java (can test only if it does not crash)
'///insert <b><i>TesttoolPath</i>/global/input/java/java.htm</b>
'///+<ul><li>wait 5 seconds</li><li>close the document</li></ul>

   if gUseSysDlg = TRUE then
      Warnlog "No test available with system file-dialog!"
   else
      FileOpen
      kontext "OeffnenDlg"
      Dateiname.Settext ConvertPath ( gTestToolPath & "global\input\java\java.htm" )
      Oeffnen.Click
      Sleep(5)
      for i=1 to 10 ' what messageboxes are expected? the only one i know of is asking if i want to install java... better cancel that one; TBO
         Kontext "Messagebox"
         if MessageBox.Exists() then
            if gPlatGroup = "unx" then Sleep(2)
            Warnlog Messagebox.GetText
            try
               Messagebox.Cancel
            catch
               Messagebox.OK
            endcatch
            i=11
         end if
         Sleep(1)
      next i
      Sleep(5)
      Call hCloseDocument
   end if
endcase

'-------------------------------------------------------------------------

function DocumentCheck ( SollFilter as String ) as boolean
'/// Checks name of the file type in the Save dialog and verifys it with a given string.
  Dim sFiltername as String

   FileSaveAs
   Kontext "SpeichernDlg"
   sFiltername = DateiTyp.GetItemText (1)
   if Instr( lcase ( sFiltername), lcase ( SollFilter ) ) <> 0 then
      DocumentCheck = TRUE
    else
      DocumentCheck = FALSE
      SollFilter = sFiltername
   end if
   SpeichernDlg.Cancel
end function

'-------------------------------------------------------------------------
