'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: f_updt.bas,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:50 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : update test for global functionality
'*
'\***********************************************************************


sub main

   use "global\update\inc\autopilo.inc"
   use "framework\update\inc\global_1.inc"
   use "framework\update\inc\global_2.inc"
   use "framework\update\inc\global_3.inc"

   call hStatusIn( "framework", "f_updt.bas", "Global update/resource-test" )

   ' check if the functionbar is active in all apllications
   call tFunctionbar_1()

   ' activate and deactivate all bars out of the contextmenu on the functionbar
   call tFunctionbar_2()

   ' check the functionality of all visible items on the functionbar
   call tFunctionbar_3()

   ' activate the hidden items of the functionbar and check their functionality
   call tFunctionbar_4()

   ' check 'configure ...' and 'costumize ...' out of the contextmenu on the 
   ' functionbar
   call tFunctionbar_5()

   ' check the 'new'-button in all apps ( without menu-functionality )
   call tFunctionbar_6()
   
   ' check the 'new'-button in all apps ( with menu-functionality )
   call tFunctionbar_7()

   ' update-test for templates+documents-dialog
   call tTemplate_DialogTest()                          

   ' check all names for samples/templates in T&D-dialog
   ' This test doesn't work on OOo for now
   ' If you want to use it on OOo please read the note at the end of this file
   if gOOO <> TRUE then
      call tTemplate_NamesCheck()   'wrn:3
   else
      printlog( "...skipping templates-check on OOo" )
   endif                 

   ' update-test for all autopilots
   call tAllAutopilots()

   ' update-test for help ( can't close )
   call tHelp_DialogTest()
   
   ' work with help tool-bar
   call tHelp_ToolBar()


   call hStatusOut()

end sub

'-------------------------------------------------------------------------

sub LoadIncludeFiles
   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   gApplication = "WRITER"
   call GetUseFiles
end sub

'-------------------------------------------------------------------------

' Note: To automate testing of templates in OOo, please do following:
' 1. delete all files that are listed in
'
'     .../framework/update/input/templdoc/*.txt
'
' 2. remove the if...endif statement around tTemplate_NamesCheck()
' 3. run the test, you'll get countless warnings
' 4. check if the template-lists have been created in
'
'     .../framework/update/input/templdoc/*.txt
'
' 5. Manually check if all templates are listed and correct
' 6. Next time you run the test the templates will be compared to these lists
'
' A separate file will be created for each language the tests are run for.
